create table CLIENT (
       NCLI     char(10)     not null,
       NOM      char(32)     not null,
       ADRESSE  char(60)     not null,
       LOCALITE char(30)     not null,
       CAT      char(2),
       COMPTE   decimal(9,2) not null,
       primary key (NCLI));

create table PRODUIT (
       NPRO     char(15)     not null,
       LIBELLE  char(60)     not null,
       PRIX     decimal(6)   not null,
       QSTOCK   decimal(8)   not null,
       primary key (NPRO))

create table COMMANDE (
       NCOM     char(12)     not null,
       NCLI     char(10)     not null,
       DATECOM  date         not null,
       primary key (NCOM),
       foreign key (NCLI) references CLIENT
           on delete no action
           on update cascade);

create table DETAIL (
       NCOM     char(12)     not null,
       NPRO     char(15)     not null,
       QCOM     decimal(8)   not null,
       primary key (NCOM,NPRO),
       foreign key (NCOM) references COMMANDE
           on delete cascade
           on update cascade,
       foreign key (NPRO) references PRODUIT
           on delete no action
           on update cascade);
