write-b -- -------------------------- --;
write   -- Les requtes du chapitre 9 --;
write   -- Les vues modifiables       --;
write-a -- -------------------------- --;

openDB CLICOM.db;

-- On vite la confusion de rle du symbole terminal ';'
-- en utilisant une variable de nom ';'.
set ; = ;;

write-b -- --------------------- --;
write   -- Vue DETAIL_ETENDU     --;
write-a -- --------------------- --;

create temporary view DETAIL_ETENDU
 as
select DET.NCOM,NCLI,DATECOM,DET.NPRO,LIBELLE,PRIX,QCOM
from   COMMANDE COM, DETAIL DET, PRODUIT PRO
where  COM.NCOM = DET.NCOM
and    DET.NPRO = PRO.NPRO;

write-b -- Etat initial de la vue --;
select * from DETAIL_ETENDU order by NCOM,NPRO;

-- Trigger d'insertion --
create temporary trigger DE_INSERT
instead of insert on DETAIL_ETENDU
for each row
begin
  insert into DETAIL(NCOM,NPRO,QCOM)
  values(new.NCOM,new.NPRO,new.QCOM)$;$
end;

-- Trigger de modification de QCOM --
create temporary trigger DE_UPDATE_QCOM
instead of update of QCOM on DETAIL_ETENDU
for each row
begin
  update DETAIL
  set    QCOM = new.QCOM
  where  NCOM = old.NCOM
  and    NPRO = old.NPRO$;$
end;

-- Trigger de modification de NCOM --
create temporary trigger DE_UPDATE_NCOM
instead of update of NCOM on DETAIL_ETENDU
for each row
begin
  update DETAIL
  set    NCOM = new.NCOM
  where  NCOM = old.NCOM
  and    NPRO = old.NPRO$;$
  delete from COMMANDE
  where  NCOM = old.NCOM
  and    NCOM not in (select NCOM from DETAIL)$;$
end;

-- Trigger de modification de LIBELLE --
create temporary trigger DE_UPDATE_LIBELLE
instead of update of LIBELLE on DETAIL_ETENDU
for each row
begin
 update PRODUIT
 set    LIBELLE = new.LIBELLE
 where  NPRO = old.NPRO$;$
end;

-- Trigger de suppression --
create temporary trigger DE_DELETE
instead of delete on DETAIL_ETENDU
for each row
begin
 delete from DETAIL
 where  NCOM = old.NCOM and NPRO = old.NPRO$;$
 delete from COMMANDE
 where  NCOM = old.NCOM and NCOM not in (select NCOM from DETAIL)$;$
end;

write-b Insertion de values ('30178','PA45',1111);
insert into DETAIL_ETENDU(NCOM,NPRO,QCOM) values('30178','PA45',1111);

write   Modification QCOM = 9999 where NCOM = '30185';
update DETAIL_ETENDU
set    QCOM = 9999
where  NCOM = '30185';

write   Modification NCOM = '30185' where NCOM = '30186';
update DETAIL_ETENDU
set    NCOM = '30185'
where  NCOM = '30186';

write   Modification LIBELLE =+ ' (New)' where NCOM = '30185' and NPRO = 'PA60';
update DETAIL_ETENDU
set    LIBELLE = 'indisponible'
where  NCOM = '30185' and NPRO = 'PA60';

write   Suppression where NCOM = '30182' and NPRO = 'PA60';
delete from DETAIL_ETENDU
where  NCOM = '30182' and NPRO = 'PA60';

write-b -- Etat final de la vue --;
select * from DETAIL_ETENDU order by NCOM,NPRO;
write-b -- Etat final de COMMANDE --;
select * from COMMANDE;

abortDB;

closeDB;

write-b Fin de script;
