-- ----------------------------------- --
-- Bases de donnes non relationnelles --
-- Le modle Attribut-valeur V3        --
-- ----------------------------------- --

openDB CLICOM.db;

create temporary table CLICOM(
   Entite    integer     not null,
   Attribut  varchar(32) not null,
   Valeur    varchar(256),
   primary key (Entite,Attribut));



-- ---------------------- --
-- Chargement des donnes --
-- ---------------------- --

extract entite = select coalesce(max(Entite),0) from CLICOM;

for cli,nom,adr,loc,cat,cpt = [select * from CLIENT];
  compute entite = $entite$ + 1;
  insert into CLICOM values($entite$,'TypeE','CLIENT');
  insert into CLICOM values($entite$,'NCLI','$cli$');
  insert into CLICOM values($entite$,'NOM','nom');
  insert into CLICOM values($entite$,'ADRESSE','adr');
  insert into CLICOM values($entite$,'LOCALITE','loc');
  insert into CLICOM values($entite$,'CAT',case when '$cat$' = '' 
                                                then null else '$cat$'
                                           end);
  insert into CLICOM values($entite$,'COMPTE',$cpt$);
endfor;

extract entite = select coalesce(max(Entite),0) from CLICOM;

for pro,lib,pri,qst = [select * from PRODUIT];
  compute entite = $entite$ + 1;
  insert into CLICOM values($entite$,'TypeE','PRODUIT');
  insert into CLICOM values($entite$,'NPRO','$pro$');
  insert into CLICOM values($entite$,'LIBELLE','lib');
  insert into CLICOM values($entite$,'PRIX',$pri$);
  insert into CLICOM values($entite$,'QSTOCK',$qst$);
endfor;

extract entite = select coalesce(max(Entite),0) from CLICOM;

for com,cli,dat = [select * from COMMANDE];
  compute entite = $entite$ + 1;
  insert into CLICOM values($entite$,'TypeE','COMMANDE');
  insert into CLICOM values($entite$,'NCOM','$com$');
  insert into CLICOM values($entite$,'NCLI','$cli$');
  insert into CLICOM values($entite$,'DATECOM','$dat$');
endfor;

extract entite = select coalesce(max(Entite),0) from CLICOM;

for com,pro,qco = [select * from DETAIL];
  compute entite = $entite$ + 1;
  insert into CLICOM values($entite$,'TypeE','DETAIL');
  insert into CLICOM values($entite$,'NCOM','$com$');
  insert into CLICOM values($entite$,'NPRO','$pro$');
  insert into CLICOM values($entite$,'QCOM',$qco$);
endfor;


-- ---------------------------------- --
-- Vue exprimant les donnes sources --
-- ---------------------------------- --

create temporary view V_CLIENT as
select 
max(case when Attribut = 'NCLI'     then Valeur end) as NCLI,
max(case when Attribut = 'NOM'      then Valeur end) as NOM,
max(case when Attribut = 'ADRESSE'  then Valeur end) as ADRESSE,
max(case when Attribut = 'LOCALITE' then Valeur end) as LOCALITE,
max(case when Attribut = 'CAT'      then Valeur end) as CAT,
max(case when Attribut = 'COMPTE'   then cast(Valeur as real) else -999999.9 end) as COMPTE
from  CLICOM
where Entite in (select Entite from CLICOM 
                 where  Attribut = 'TypeE' and Valeur = 'CLIENT')
group by Entite;


write-b Table CLICOM ;
select * from CLICOM order by Entite;

write-b Table source CLIENT reconstitue;
select * from V_CLIENT;

closeDB;

write-b Fin de script;