-- -------------------- --
-- Consulter un compte  --
-- -------------------- --

openDB BLOCKCHAIN.db;

extract NC = select count(*) from COMPTE;
if ($NC$ = 0);
   showMessage Aucun compte n'a encore t cr.@nOpration annule.;
   goto END;
endif;

ask compte = [/bSelectionner un compte]
              Votre nom priv:[!select NomPrive,AdresseCPT from COMPTE order by NomPrive];
if ('$DIALOGbutton$' = 'Cancel') goto END;

write-b Transactions de votre compte;
select Source,Operation,Montant,Destinataire,DateEnreg,InBloc
from (
   select S.NomPrive as Source,Operation,null as Montant,null as Destinataire,
          T.DateEnreg as DateEnreg,case when IDBloc is null then null else 'oui' end as InBloc
   from   COMPTE S, BTRANSACTION T
   where  T.Source  = '$compte$'
   and    T.Source  = S.AdresseCPT
   and    Operation = 'REGISTER'
      union all
   select null as Source,Operation,Montant,M.NomPrive as Destinataire,
          T.DateEnreg as DateEnreg,case when IDBloc is null then null else 'oui' end as InBloc
   from   BTRANSACTION T, COMPTE as M
   where  T.Destin  = '$compte$'
   and    T.Destin  = M.AdresseCPT
   and    Operation = 'DEPOSIT'
      union all
   select S.NomPrive as Source,Operation,Montant,R.NomPrive as Destinataire,
          T.DateEnreg as DateEnreg,case when IDBloc is null then null else 'oui' end as InBloc
   from   COMPTE S, BTRANSACTION T, COMPTE R
   where  (T.Source = '$compte$' or T.Destin = '$compte$')
   and    T.Source  = S.AdresseCPT
   and    T.Destin  = R.AdresseCPT
   and    Operation = 'TRANSFER'
      )
order by DateEnreg;

write-b Solde de votre compte;
select Compte, sum(plusD) as "Dpt",
               sum(plusT) as "Reu",
              -sum(minus) as "Transfr",
       sum(plusD) + sum(plusT) - sum(minus) as Solde
from (
   select M.NomPrive as Compte,Montant as plusD,0 as plusT,0 as minus
   from   BTRANSACTION T, COMPTE M
   where  T.Destin  = '$compte$'
   and    T.Destin  = M.AdresseCPT
   and    Operation = 'DEPOSIT'
      union all
   select M.NomPrive as Compte,0 as plusD,Montant as plusT,0 as minus
   from   BTRANSACTION T, COMPTE M
   where  T.Destin  = '$compte$'
   and    T.Destin  = M.AdresseCPT
   and    Operation = 'TRANSFER'
      union all
   select M.NomPrive as Compte,0 as plusD,0 as plusT,Montant as minus
   from   BTRANSACTION T, COMPTE M
   where  T.Source = '$compte$'
   and    T.Source = M.AdresseCPT
   and    Operation = 'TRANSFER'   
      );
write;

label END;

closeDB;

return;
