-- ----------------------- --
-- Crer un bloc           --
-- ----------------------- --

openDB BLOCKCHAIN.db;

extract NT = select count(*) from BTRANSACTION where IDBloc is null;
if ($NT$ = 0);
   write Il n'y a pas de transactions en attente. Operation annule.;
   goto END;
endif;

extract NB = select count(*) from BLOC;
if ($NB$ = 0) set precedent = ;
if ($NB$ > 0) extract precedent = select IDBloc from BLOC order by DateEnreg desc;

extract transList = select group_concat2(
                           case Operation
                              when 'REGISTER'
                                 then IDTrans||';'||Operation||';'||Source||';'
                                      ||DateEnreg||';'||Signature
                              when 'DEPOSIT'
                                 then IDTrans||';'||Operation||';'||Destin||';'
                                      ||cast(Montant as char)||';'||DateEnreg||';'||Signature
                              when 'TRANSFER'
                                 then IDTrans||';'||Operation||';'||Source||';'||Destin||';'
                                      ||cast(Montant as char)||';'||DateEnreg||';'||Signature
                              else 'Transaction de type inconnu'
                           end,0,CleTrans,1,'#')
                    from   BTRANSACTION
                    where  IDBloc is null;

set dateEnreg = $dateclock$;

set blocData = $precedent$#$transList$#$dateEnreg$;

set k = 20;
set format = hexa;
set hashTrials = 5000000;
compute hashPrefix = repeat('0',$k$);

write-b Soyez patient. Cette opration de minage peut prendre "un certain temps" !;

start-timer;
function hash,nonce,nHash = LStr:miningHash $blocData$,$hashPrefix$,$hashTrials$,$format$;
write-ba Temps de minage = $timer$ pour $nHash$ calculs de hash;

if ('$nonce$' = '' and $nHash$ = 0) write Une erreur est survenue lors du minage.;
if ('$nonce$' = '' and $nHash$ > 0) write Aucun hash lgal n'a t trouv. Augmenter le nombre d'essais.;

write IDBloc       = $hash$;
write Challenge(k) = $k$;
write Transact     = $NT$;
write Nonce        = $nonce$;
write DateEnreg    = $dateEnreg$;
write Status       = 0;
write BlocPrec     = $precedent$;

insert into BLOC(IDBloc,Transact,Nonce,DateEnreg,BlocPrec)
       values('$hash$',$NT$,'$nonce$','$dateEnreg$',
              case when '$precedent$' = '' then null else '$precedent$' end);

update BTRANSACTION
set   IDBloc = '$hash$'
where IDBloc is null;

commitDB;

write-b Bloc cr avec $NT$ transaction(s).;

label END;
   write;
   closeDB;

   return;
