-- ----------------------- --
-- Examiner la blockchain  --
-- ----------------------- --

openDB BLOCKCHAIN.db;

execSQL UTIL-SELECT-parameters-standard-1.sql;

for bId,hash,NT,nonce,dateEnreg,statut,precedent
           = [select CleBloc,IDBloc,Transact,Nonce,DateEnreg,Statut,
                     case when BlocPrec is null then '--' else BlocPrec end
              from   BLOC order by DateEnreg desc];

   write-b Bloc n $bId$;
   write @S4Bloc hash:      $hash$;
   write @S4Nbre transact:  $NT$;
   write @S4Nonce:          $nonce$;
   write @S4Date cration:  $dateEnreg$;
   write @S4Statut:         $statut$;
   write @S4Hash precdent: $precedent$;

   set bar11 = @S4+-;
   set head1 = @S4| ;
   set bar21 = @S4+-;
   set data1 = @S4| ;
   set bar31 = @S4+-;

   select Source,Operation,Montant,Destinataire,DateCreation
   from (
      select S.NomPrive as Source,Operation,null as Montant,null as Destinataire,
             T.DateEnreg as DateCreation
      from   COMPTE S, BTRANSACTION T
      where  T.Source = S.AdresseCPT
      and    T.IDBloc = '$hash$'
      and    Operation = 'REGISTER'
         union all
      select null as Source,Operation,Montant,M.NomPrive as Destinataire,
             T.DateEnreg as DateCreation
      from   BTRANSACTION T, COMPTE as M
      where  T.Destin = M.AdresseCPT
      and    T.IDBloc = '$hash$'
      and    Operation = 'DEPOSIT'
         union all
      select S.NomPrive as Source,Operation,Montant,R.NomPrive as Destinataire,
             T.DateEnreg as DateCreation
      from   COMPTE S, BTRANSACTION T, COMPTE R
      where  T.Source = S.AdresseCPT
      and    T.Destin = R.AdresseCPT
      and    T.IDBloc = '$hash$'
      and    Operation = 'TRANSFER'
         )
   order by DateCreation;

endfor;

write-b Transactions en attente (pas encore incluses dans un bloc);
select Source,Operation,Montant,Destinataire,DateCreation
from (
   select S.NomPrive as Source,Operation,null as Montant,null as Destinataire,
          T.DateEnreg as DateCreation
   from   COMPTE S, BTRANSACTION T
   where  T.Source = S.AdresseCPT
   and    T.IDBloc is null
   and    Operation = 'REGISTER'
      union all
   select null as Source,Operation,Montant,M.NomPrive as Destinataire,
          T.DateEnreg as DateCreation
   from   BTRANSACTION T, COMPTE as M
   where  T.Destin = M.AdresseCPT
   and    T.IDBloc is null
   and    Operation = 'DEPOSIT'
      union all
   select S.NomPrive as Source,Operation,Montant,R.NomPrive as Destinataire,
          T.DateEnreg as DateCreation
   from   COMPTE S, BTRANSACTION T, COMPTE R
   where  T.Source = S.AdresseCPT
   and    T.Destin = R.AdresseCPT
   and    T.IDBloc is null
   and    Operation = 'TRANSFER'
      )
order by DateCreation;

write;

closeDB;

execSQL UTIL-SELECT-parameters-standard-1.sql;

