-- ------------------------ --
-- Valider une transaction  --
-- ------------------------ --

openDB BLOCKCHAIN.db;

write;
-- Afficher le contenu de toutes les transactions.
select T.CleTrans,S.NomPrive as Source,T.Operation,R.NomPrive as Destinataire,
       T.Montant,T.DateEnreg,T.Source,T.Destin
       from BTRANSACTION T
               left join
            COMPTE S on (T.Source = S.AdresseCPT)
               left join
            COMPTE R on (T.Destin = R.AdresseCPT);

ask cleTrans = [/bSelectionner une transaction  valider]
               Transaction:[!select cast(CleTrans as char)||' - '||Operation,CleTrans
                             from   BTRANSACTION order by CleTrans];
if ('$DIALOGbutton$' = 'Cancel') goto END;

extract idTrans,operation,source,destin,montant,dateEnreg,signature
        = select IDTrans,Operation,Source,Destin,Montant,DateEnreg,Signature
          from   BTRANSACTION where CleTrans = '$cleTrans$';

write-b Validation de la transaction $operation$ : [$cleTrans$] [$idTrans$];

if ('$operation$' = 'REGISTER') goto REGISTER; 
if ('$operation$' = 'DEPOSIT')  goto DEPOSIT; 
if ('$operation$' = 'TRANSFER') goto TRANSFER; 
goto END;


label REGISTER;
--------------
   -- Le compte "source" existe dans REPERTOIRE
   -- La signature de la transaction correspond  ses composants

   extract N,clePublique= select count(*),max(ClePublique) from REPERTOIRE
                          where  AdresseCPT = '$source$';
   if ($N$ = 0);
      write @S3- Le membre "$source$" n'a pas encore t enregistr.;
   else;
      write @S3- Le membre "$source$" a t enregistr.;
   endif;

   -- Decryptage de "signature" via la cl REPERTOIRE.ClePublique
   function trans = LStr:decryptRSA {$signature$},{$clePublique$};
   if ('$idTrans$;$operation$;$source$;$dateEnreg$' = '$trans$');
      write @S3- La signature de la transaction correspond  ses composants.;
      write @S6- Dechiffrage signature: $trans$;;
   else;
      write @S3- La transaction est corrompue : sa signature ne correspond pas  ses composants.;
      write @S6- Composants:            $idTrans$;$operation$;$adresseCPT$;$dateEnreg$;
      write @S6- Dechiffrage signature: $trans$;;
   endif;
   goto END;

label DEPOSIT;
-------------
   -- Le compte "destin" existe dans REPERTOIRE
   -- La signature de la transaction correspond  ses composants

   extract N,clePublique = select count(*),max(ClePublique) from REPERTOIRE
                           where  AdresseCPT = '$destin$';
   if ($N$ = 0);
      write @S3- Le compte "$destin$" n'a pas encore t enregistr.;
   else;
      write @S3- Le compte "$destin$" a t enregistr.;
   endif;

   function trans = LStr:decryptRSA {$signature$},{$clePublique$};
   if ('$idTrans$;$operation$;$destin$;$montant$;$dateEnreg$' = '$trans$');
      write @S3- La signature de la transaction correspond  ses composants.;
      write @S6- Dechiffrage signature: $trans$;;
   else;
      write @S3- La transaction est corrompue : sa signature ne correspond pas  ses composants.;
      write @S6- Components:            $idTrans$;$operation$;$destin$;$montant$;$dateEnreg$;
      write @S6- Dechiffrage signature: $trans$;
   endif;
   goto END;

label TRANSFER;
--------------
   -- Le compte "source" existe dans REPERTOIRE
   -- Le compte "destin" existe dans REPERTOIRE
   -- Le solde du compte "source" est >= "montant"
   -- La signature de la transaction correspond  ses composants

   extract N1,clePublique = select count(*),max(ClePublique) from REPERTOIRE
                             where  AdresseCPT = '$source$';
   extract N2 = select count(*) from REPERTOIRE
                where  AdresseCPT = '$destin$';
   if ($N1$ = 0);
      write @S3- Le compte source "$source$" n'a pas encore t enregistr.;
   else;
      write @S3- Le compte source "$source$" a t enregistr.;
   endif;

   if ($N2$ = 0);
      write @S3- Le compte destinataire "$destin$" n'a pas encore t enregistr.;
   else;
      write @S3- Le compte destinataire "$destin$" a t enregistr.;
   endif;

   extract plusD = select coalesce(sum(montant),0) from BTRANSACTION
                   where  operation = 'DEPOSIT'  and Destin = '$source$'  and DateEnreg < '$dateEnreg$';
   extract plusT = select coalesce(sum(montant),0) from BTRANSACTION
                   where  operation = 'TRANSFER' and Destin = '$source$'  and DateEnreg < '$dateEnreg$';
   extract minus = select coalesce(sum(montant),0) from BTRANSACTION
                   where  operation = 'TRANSFER' and Source = '$source$' and DateEnreg < '$dateEnreg$';
   compute balance = $plusD$ + $plusT$ - $minus$;

   if ($balance$ < $montant$);
      write @S3- Solde du compte source insuffisant($balance$). L'operation ne peut tre excute.;
   else;
      write @S3- Solde du compte source suffisant($balance$). L'operation peut tre excute.;
   endif;

   function trans = LStr:decryptRSA {$signature$},{$clePublique$};
   if ('$idTrans$;$operation$;$source$;$destin$;$montant$;$dateEnreg$' = '$trans$');
      write @S3- La signature de la transaction correspond  ses composants.;
      write @S6- Dechiffrage signature: $trans$;
   else;
      write @S3- La transaction est corrompue : sa signature ne correspond pas  ses composants.;
      write @S6- Composants:            $idTrans$;$operation$;$destin$;$montant$;$dateEnreg$;
      write @S6- Dechiffrage signature: $trans$;
   endif;
   goto END;

label END;
   write;
   closeDB;

   return;

