
-- -----------------------------------------------------------------------------
-- Gestionnaire du prototype de la base de donnes CLICOM.
-- Date : 2022-06-29 - 19:49:13.212
-- Gnrateur version v1.1
-- -----------------------------------------------------------------------------


openDB D:/-jlh-/DBMS/Python-DB_v5/Databases/CLICOM.db;

onError continue;

-- Paramtres d'affichage --
set defaultLimit = 50;
set defaultxText = 72;
set defaultyText = 24;

set limit = $defaultLimit$;
set xText = $defaultxText$;
set yText = $defaultyText$;

-- Paramtres de fonctionnement --
set append = 0;
set exploreColumns = 1;
set execMode = 1;
set resultat = ;

-- Registres des identifiants primaires des tables --
set idCLIENT = ;
set idCOMMANDE = ;
set idDETAIL = ;
set idPRODUIT = ;

-- --------------------------------- --
-- Panneau de commande et aiguillages --
-- --------------------------------- --

set oper = 1;
while (True);
   label SELECTION;
	parameter styleBoxFrame = relief;
	parameter styleBoxMessage = flat;
	askCombo [selectOne-u oper = {Crer lignes}  |CLIENT|COMMANDE|DETAIL|PRODUIT
 		||{Modifier lignes} |CLIENT|COMMANDE|DETAIL|PRODUIT
 		||{Supprimer lignes}|CLIENT|COMMANDE|DETAIL|PRODUIT
 		||{Lister tables}   |CLIENT|COMMANDE|DETAIL|PRODUIT
 		||{Explorer tables} |CLIENT|COMMANDE|DETAIL|PRODUIT]
 		|[ask-u limit,xText,yText = [/bParamtres de la fonction "Lister tables"]
 		 Nombre max de lignes de donnes  extraire (1,100000)
 		|Largeur de la fentre(24,132)
 		|Hauteur de la fentre (6,72)]
 		|[selectOne-u exploreColumns = [/bParamtres de la fonction "Explorer tables". Les donnes sont prsentes :]
 		 en 1 colonne||en 3 colonnes]
 		|[selectOne-u execMode = [/bExecution des mises  jour]
 		 en mode test||en mode rel]
 		|[selectMany-u append = Cumuler rsultats];
	if ('$DIALOGbutton$' = 'Cancel') exit;
		if (isNotNumeric('$limit$'))  set limit = $defaultLimit$;
		if (isNotNumeric('$xText$'))  set xText = $defaultxText$;
		if (isNotNumeric('$yText$'))  set yText = $defaultyText$;
		if ($limit$ not between  1  and 100000) set limit = $defaultLimit$;
		if ($xText$ not between  24 and 132)    set xText = $defaultxText$;
		if ($yText$ not between  6  and 72)     set yText = $defaultyText$;
		if ($exploreColumns$ = 1) set -sep = |;
		if ($exploreColumns$ = 2) set -sep = ||;
		if ($append$ = 0) set outMode = outputOpen;
		if ($append$ = 1) set outMode = outputAppend;
	if ($oper$ = 1) goto creer-CLIENT;
	if ($oper$ = 2) goto creer-COMMANDE;
	if ($oper$ = 3) goto creer-DETAIL;
	if ($oper$ = 4) goto creer-PRODUIT;
	if ($oper$ = 5) goto modifier-CLIENT;
	if ($oper$ = 6) goto modifier-COMMANDE;
	if ($oper$ = 7) goto modifier-DETAIL;
	if ($oper$ = 8) goto modifier-PRODUIT;
	if ($oper$ = 9) goto supprimer-CLIENT;
	if ($oper$ = 10) goto supprimer-COMMANDE;
	if ($oper$ = 11) goto supprimer-DETAIL;
	if ($oper$ = 12) goto supprimer-PRODUIT;
	if ($oper$ = 13) goto lister-CLIENT;
	if ($oper$ = 14) goto lister-COMMANDE;
	if ($oper$ = 15) goto lister-DETAIL;
	if ($oper$ = 16) goto lister-PRODUIT;
	if ($oper$ = 17) goto explorer-CLIENT;
	if ($oper$ = 18) goto explorer-COMMANDE;
	if ($oper$ = 19) goto explorer-DETAIL;
	if ($oper$ = 20) goto explorer-PRODUIT;
   label VISITER;
	if ('$idCLIENT$' <> '') goto explorer-CLIENT;
	if ('$idCOMMANDE$' <> '') goto explorer-COMMANDE;
	if ('$idDETAIL$' <> '') goto explorer-DETAIL;
	if ('$idPRODUIT$' <> '') goto explorer-PRODUIT;
endwhile;
onError stop;
abortDB;
closeDB;
stop;

-- ------------------------------------- --
-- GENERATION DES OPERATIONS DE CREATION --
-- ------------------------------------- --

-----------------------
label creer-CLIENT;
-----------------------
set operation = CREER;
set tableCourante = CLIENT;

while (True);
   ask NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE = [/bCrer CLIENT] NCLI*:|NOM*:|ADRESSE*:|LOCALITE*:|CAT  :|COMPTE*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   if ('$COMPTE$' = '') set COMPTE = null;
   insert into CLIENT values(case when 'NCLI' = '' then null else 'NCLI' end,case when 'NOM' = '' then null else 'NOM' end,case when 'ADRESSE' = '' then null else 'ADRESSE' end,case when 'LOCALITE' = '' then null else 'LOCALITE' end,case when 'CAT' = '' then null else 'CAT' end,$COMPTE$);
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;
goto SELECTION;

-----------------------
label creer-COMMANDE;
-----------------------
set operation = CREER;
set tableCourante = COMMANDE;

while (True);
   ask NCOM,NCLI,DATECOM = [/bCrer COMMANDE] NCOM*:|NCLI*:[select NCLI from CLIENT order by NCLI]|DATECOM*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   insert into COMMANDE values(case when 'NCOM' = '' then null else 'NCOM' end,case when 'NCLI' = '' then null else 'NCLI' end,case when 'DATECOM' = '' then null else 'DATECOM' end);
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;
goto SELECTION;

-----------------------
label creer-DETAIL;
-----------------------
set operation = CREER;
set tableCourante = DETAIL;

while (True);
   ask NCOM,NPRO,QCOM = [/bCrer DETAIL] NCOM*:[select NCOM from COMMANDE order by NCOM]|NPRO*:[select NPRO from PRODUIT order by NPRO]|QCOM*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   if ('$QCOM$' = '') set QCOM = null;
   insert into DETAIL values(case when 'NCOM' = '' then null else 'NCOM' end,case when 'NPRO' = '' then null else 'NPRO' end,$QCOM$);
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;
goto SELECTION;

-----------------------
label creer-PRODUIT;
-----------------------
set operation = CREER;
set tableCourante = PRODUIT;

while (True);
   ask NPRO,LIBELLE,PRIX,QSTOCK = [/bCrer PRODUIT] NPRO*:|LIBELLE*:|PRIX*:|QSTOCK*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   if ('$PRIX$' = '') set PRIX = null;
   if ('$QSTOCK$' = '') set QSTOCK = null;
   insert into PRODUIT values(case when 'NPRO' = '' then null else 'NPRO' end,case when 'LIBELLE' = '' then null else 'LIBELLE' end,$PRIX$,$QSTOCK$);
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;
goto SELECTION;


-- ----------------------------------------- --
-- GENERATION DES OPERATIONS DE MODIFICATION --
-- ----------------------------------------- --

-----------------------
label modifier-CLIENT;
-----------------------
set operation = MODIFIER;
set tableCourante = CLIENT;

while (True);
   ask id = [/bModifier CLIENT] CLIENT:[select NCLI from CLIENT order by NCLI];

   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE = select NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE from CLIENT where cast(NCLI as char) = 'id';


   ask-u NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE = [/bModifier CLIENT] NCLI*:|NOM*:|ADRESSE*:|LOCALITE*:|CAT  :|COMPTE*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;

   if ('COMPTE' = '') set COMPTE = null;

   update CLIENT set 
          NCLI = case when 'NCLI' = '' then null else 'NCLI' end,
          NOM = case when 'NOM' = '' then null else 'NOM' end,
          ADRESSE = case when 'ADRESSE' = '' then null else 'ADRESSE' end,
          LOCALITE = case when 'LOCALITE' = '' then null else 'LOCALITE' end,
          CAT = case when 'CAT' = '' then null else 'CAT' end,
          COMPTE = COMPTE
   where cast(NCLI as char) = 'id';

   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;

-----------------------
label modifier-COMMANDE;
-----------------------
set operation = MODIFIER;
set tableCourante = COMMANDE;

while (True);
   ask id = [/bModifier COMMANDE] COMMANDE:[select NCOM from COMMANDE order by NCOM];

   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NCOM,NCLI,DATECOM = select NCOM,NCLI,DATECOM from COMMANDE where cast(NCOM as char) = 'id';


   ask-u NCOM,NCLI,DATECOM = [/bModifier COMMANDE] NCOM*:|NCLI*:[select NCLI from CLIENT order by NCLI]|DATECOM*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;


   update COMMANDE set 
          NCOM = case when 'NCOM' = '' then null else 'NCOM' end,
          NCLI = case when 'NCLI' = '' then null else 'NCLI' end,
          DATECOM = case when 'DATECOM' = '' then null else 'DATECOM' end
   where cast(NCOM as char) = 'id';

   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;

-----------------------
label modifier-DETAIL;
-----------------------
set operation = MODIFIER;
set tableCourante = DETAIL;

while (True);
   ask id = [/bModifier DETAIL] DETAIL:[select cast(NCOM as char)||'-'||cast(NPRO as char) from DETAIL order by NCOM,NPRO];

   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NCOM,NPRO,QCOM = select NCOM,NPRO,QCOM from DETAIL where cast(NCOM as char)||'-'||cast(NPRO as char) = 'id';


   ask-u NCOM,NPRO,QCOM = [/bModifier DETAIL] NCOM*:[select NCOM from COMMANDE order by NCOM]|NPRO*:[select NPRO from PRODUIT order by NPRO]|QCOM*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;

   if ('QCOM' = '') set QCOM = null;

   update DETAIL set 
          NCOM = case when 'NCOM' = '' then null else 'NCOM' end,
          NPRO = case when 'NPRO' = '' then null else 'NPRO' end,
          QCOM = QCOM
   where cast(NCOM as char)||'-'||cast(NPRO as char) = 'id';

   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;

-----------------------
label modifier-PRODUIT;
-----------------------
set operation = MODIFIER;
set tableCourante = PRODUIT;

while (True);
   ask id = [/bModifier PRODUIT] PRODUIT:[select NPRO from PRODUIT order by NPRO];

   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NPRO,LIBELLE,PRIX,QSTOCK = select NPRO,LIBELLE,PRIX,QSTOCK from PRODUIT where cast(NPRO as char) = 'id';


   ask-u NPRO,LIBELLE,PRIX,QSTOCK = [/bModifier PRODUIT] NPRO*:|LIBELLE*:|PRIX*:|QSTOCK*:;
   if ('$DIALOGbutton$' = 'Cancel') exit;

   if ('PRIX' = '') set PRIX = null;
   if ('QSTOCK' = '') set QSTOCK = null;

   update PRODUIT set 
          NPRO = case when 'NPRO' = '' then null else 'NPRO' end,
          LIBELLE = case when 'LIBELLE' = '' then null else 'LIBELLE' end,
          PRIX = PRIX,
          QSTOCK = QSTOCK
   where cast(NPRO as char) = 'id';

   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;


-- ----------------------------------------- --
-- GENERATION DES OPERATIONS DE SUPPRESSION  --
-- ----------------------------------------- --

-----------------------
label supprimer-CLIENT;
-----------------------
set operation = SUPPRIMER;
set tableCourante = CLIENT;

while (True);
   ask id = [/bSupprimer CLIENT] CLIENT:[select NCLI from CLIENT order by NCLI];
   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE = select NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE from CLIENT where cast(NCLI as char) = 'id';

   showData NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE = [/bConfirmer ou annuler la suppression] NCLI:|NOM:|ADRESSE:|LOCALITE:|CAT:|COMPTE:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   delete from CLIENT where cast(NCLI as char) = 'id';
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;

-----------------------
label supprimer-COMMANDE;
-----------------------
set operation = SUPPRIMER;
set tableCourante = COMMANDE;

while (True);
   ask id = [/bSupprimer COMMANDE] COMMANDE:[select NCOM from COMMANDE order by NCOM];
   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NCOM,NCLI,DATECOM = select NCOM,NCLI,DATECOM from COMMANDE where cast(NCOM as char) = 'id';

   showData NCOM,NCLI,DATECOM = [/bConfirmer ou annuler la suppression] NCOM:|NCLI:|DATECOM:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   delete from COMMANDE where cast(NCOM as char) = 'id';
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;

-----------------------
label supprimer-DETAIL;
-----------------------
set operation = SUPPRIMER;
set tableCourante = DETAIL;

while (True);
   ask id = [/bSupprimer DETAIL] DETAIL:[select cast(NCOM as char)||'-'||cast(NPRO as char) from DETAIL order by NCOM,NPRO];
   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NCOM,NPRO,QCOM = select NCOM,NPRO,QCOM from DETAIL where cast(NCOM as char)||'-'||cast(NPRO as char) = 'id';

   showData NCOM,NPRO,QCOM = [/bConfirmer ou annuler la suppression] NCOM:|NPRO:|QCOM:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   delete from DETAIL where cast(NCOM as char)||'-'||cast(NPRO as char) = 'id';
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;

-----------------------
label supprimer-PRODUIT;
-----------------------
set operation = SUPPRIMER;
set tableCourante = PRODUIT;

while (True);
   ask id = [/bSupprimer PRODUIT] PRODUIT:[select NPRO from PRODUIT order by NPRO];
   if ('$DIALOGbutton$' = 'Cancel') exit;

   extract NPRO,LIBELLE,PRIX,QSTOCK = select NPRO,LIBELLE,PRIX,QSTOCK from PRODUIT where cast(NPRO as char) = 'id';

   showData NPRO,LIBELLE,PRIX,QSTOCK = [/bConfirmer ou annuler la suppression] NPRO:|LIBELLE:|PRIX:|QSTOCK:;
   if ('$DIALOGbutton$' = 'Cancel') exit;
   delete from PRODUIT where cast(NPRO as char) = 'id';
   if ('$SQLdiag$' <> 'OK');
      execSQL D:\-jlh-\DBMS\Python-DB_v5\Scripts/BD-2022/Chapitre-19/traiterErreurSQL.sql;
   else;
      if ($execMode$ = 2) commitDB;
   endif;
endwhile;

goto SELECTION;


-- ------------------------------------ --
-- GENERATION DES OPERATIONS DE LISTAGE --
-- ------------------------------------ --

-----------------------
label lister-CLIENT;
-----------------------
set operation = LISTER;
set tableCourante = CLIENT;

$outMode$ resultat.var;

write-b Table CLIENT;
select * from CLIENT limit $limit$;
showText resultat = [/w0/x$xText$/y$yText$/bContenu de la table CLIENT];
outputAppend console;

goto SELECTION;

-----------------------
label lister-COMMANDE;
-----------------------
set operation = LISTER;
set tableCourante = COMMANDE;

$outMode$ resultat.var;

write-b Table COMMANDE;
select * from COMMANDE limit $limit$;
showText resultat = [/w0/x$xText$/y$yText$/bContenu de la table COMMANDE];
outputAppend console;

goto SELECTION;

-----------------------
label lister-DETAIL;
-----------------------
set operation = LISTER;
set tableCourante = DETAIL;

$outMode$ resultat.var;

write-b Table DETAIL;
select * from DETAIL limit $limit$;
showText resultat = [/w0/x$xText$/y$yText$/bContenu de la table DETAIL];
outputAppend console;

goto SELECTION;

-----------------------
label lister-PRODUIT;
-----------------------
set operation = LISTER;
set tableCourante = PRODUIT;

$outMode$ resultat.var;

write-b Table PRODUIT;
select * from PRODUIT limit $limit$;
showText resultat = [/w0/x$xText$/y$yText$/bContenu de la table PRODUIT];
outputAppend console;

goto SELECTION;


-- --------------------------------------- --
-- GENERATION DES OPERATIONS D'EXPLORATION --
-- --------------------------------------- --

-----------------------
label explorer-CLIENT;
-----------------------
set operation = EXPLORER;
set tableCourante = CLIENT;

parameter styleGeneralMessage = relief;
if ($exploreColumns$ = 1) parameter styleBoxFrame = relief;
if ($exploreColumns$ = 2) parameter styleBoxFrame = flat;
if ($exploreColumns$ = 1) parameter styleBoxMessage = flat;
if ($exploreColumns$ = 2) parameter styleBoxMessage = relief;
parameter styleEntry = flat;
parameter styleText = flat;

set id = $idCLIENT$;

-- New or undergoing exploration? --
if ('$id$' = '');
   ask id = [/bExplorer CLIENT] CLIENT:[select NCLI from CLIENT order by NCLI]
   if ('$DIALOGbutton$' = 'Cancel' or '$id$' = '') goto SELECTION;
endif;

-- Extract data from selected CLIENT row --
extract NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE  
        = select NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE 
          from CLIENT 
          where cast(NCLI as char) = 'id';

-- Extract data from referenced rows   --

-- Extract data from referencing rows --
outputOpen -COMMANDE-5.var;
select * from COMMANDE where cast(NCLI as char) = 'id';
outputAppend console;

-- Empty navigation registers --
set idCLIENT = ;
set idCOMMANDE = ;

-- Building the display box --
askCombo [/bEnvironnement de CLIENT $id$]
         [/y10showData NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE = [/bLigne CLIENT courante] NCLI:|NOM:|ADRESSE:|LOCALITE:|CAT:|COMPTE:]
         $-sep$[showText -COMMANDE-5 = [/b/w0/x48/y6COMMANDE rfrenant CLIENT via (NCLI)]]
         |[ask idCOMMANDE = Visiter COMMANDE:[select cast(NCOM as char) from COMMANDE where cast(NCLI as char) = 'id']];
if ('$DIALOGbutton$' = 'Cancel') goto SELECTION;

-- Continue the exploration --
goto VISITER;

-----------------------
label explorer-COMMANDE;
-----------------------
set operation = EXPLORER;
set tableCourante = COMMANDE;

parameter styleGeneralMessage = relief;
if ($exploreColumns$ = 1) parameter styleBoxFrame = relief;
if ($exploreColumns$ = 2) parameter styleBoxFrame = flat;
if ($exploreColumns$ = 1) parameter styleBoxMessage = flat;
if ($exploreColumns$ = 2) parameter styleBoxMessage = relief;
parameter styleEntry = flat;
parameter styleText = flat;

set id = $idCOMMANDE$;

-- New or undergoing exploration? --
if ('$id$' = '');
   ask id = [/bExplorer COMMANDE] COMMANDE:[select NCOM from COMMANDE order by NCOM]
   if ('$DIALOGbutton$' = 'Cancel' or '$id$' = '') goto SELECTION;
endif;

-- Extract data from selected COMMANDE row --
extract NCOM,NCLI,DATECOM  
        = select NCOM,NCLI,DATECOM 
          from COMMANDE 
          where cast(NCOM as char) = 'id';

-- Extract data from referenced rows   --
extract NCLI-5,NOM-5,ADRESSE-5,LOCALITE-5,CAT-5,COMPTE-5 
        = select NCLI,NOM,ADRESSE,LOCALITE,CAT,COMPTE 
          from CLIENT 
          where cast(NCLI as char) = '$NCLI$';

-- Extract data from referencing rows --
outputOpen -DETAIL-7.var;
select * from DETAIL where cast(NCOM as char) = 'id';
outputAppend console;

-- Empty navigation registers --
set idCLIENT = ;
set idCOMMANDE = ;
set idDETAIL = ;

-- Building the display box --
askCombo [/bEnvironnement de COMMANDE $id$]
         [/y10showData NCOM,NCLI,DATECOM = [/bLigne COMMANDE courante] NCOM:|NCLI:|DATECOM:]
         $-sep$[showData NCLI-5,NOM-5,ADRESSE-5,LOCALITE-5,CAT-5,COMPTE-5 = [/bCLIENT rfrenc par COMMANDE via (NCLI)] @S1NCLI:|@S1NOM:|@S1ADRESSE:|@S1LOCALITE:|@S1CAT:|@S1COMPTE:]
         |[selectMany checkCLIENT = Visiter CLIENT]
         $-sep$[showText -DETAIL-7 = [/b/w0/x48/y6DETAIL rfrenant COMMANDE via (NCOM)]]
         |[ask idDETAIL = Visiter DETAIL:[select cast(NCOM as char)||'-'||cast(NPRO as char) from DETAIL where cast(NCOM as char) = 'id']];

if ($checkCLIENT$ = 1);
   set idCLIENT = $NCLI-5$;
endif;
if ('$DIALOGbutton$' = 'Cancel') goto SELECTION;

-- Continue the exploration --
goto VISITER;

-----------------------
label explorer-DETAIL;
-----------------------
set operation = EXPLORER;
set tableCourante = DETAIL;

parameter styleGeneralMessage = relief;
if ($exploreColumns$ = 1) parameter styleBoxFrame = relief;
if ($exploreColumns$ = 2) parameter styleBoxFrame = flat;
if ($exploreColumns$ = 1) parameter styleBoxMessage = flat;
if ($exploreColumns$ = 2) parameter styleBoxMessage = relief;
parameter styleEntry = flat;
parameter styleText = flat;

set id = $idDETAIL$;

-- New or undergoing exploration? --
if ('$id$' = '');
   ask id = [/bExplorer DETAIL] DETAIL:[select cast(NCOM as char)||'-'||cast(NPRO as char) from DETAIL order by NCOM,NPRO]
   if ('$DIALOGbutton$' = 'Cancel' or '$id$' = '') goto SELECTION;
endif;

-- Extract data from selected DETAIL row --
extract NCOM,NPRO,QCOM  
        = select NCOM,NPRO,QCOM 
          from DETAIL 
          where cast(NCOM as char)||'-'||cast(NPRO as char) = 'id';

-- Extract data from referenced rows   --
extract NPRO-6,LIBELLE-6,PRIX-6,QSTOCK-6 
        = select NPRO,LIBELLE,PRIX,QSTOCK 
          from PRODUIT 
          where cast(NPRO as char) = '$NPRO$';
extract NCOM-7,NCLI-7,DATECOM-7 
        = select NCOM,NCLI,DATECOM 
          from COMMANDE 
          where cast(NCOM as char) = '$NCOM$';

-- Extract data from referencing rows --

-- Empty navigation registers --
set idCOMMANDE = ;
set idDETAIL = ;
set idPRODUIT = ;

-- Building the display box --
askCombo [/bEnvironnement de DETAIL $id$]
         [/y10showData NCOM,NPRO,QCOM = [/bLigne DETAIL courante] NCOM:|NPRO:|QCOM:]
         $-sep$[showData NPRO-6,LIBELLE-6,PRIX-6,QSTOCK-6 = [/bPRODUIT rfrenc par DETAIL via (NPRO)] @S1NPRO:|@S1LIBELLE:|@S1PRIX:|@S1QSTOCK:]
         |[selectMany checkPRODUIT = Visiter PRODUIT]
         |[showData NCOM-7,NCLI-7,DATECOM-7 = [/bCOMMANDE rfrenc par DETAIL via (NCOM)] @S1NCOM:|@S1NCLI:|@S1DATECOM:]
         |[selectMany checkCOMMANDE = Visiter COMMANDE];

if ($checkPRODUIT$ = 1);
   set idPRODUIT = $NPRO-6$;
endif;
if ($checkCOMMANDE$ = 1);
   set idCOMMANDE = $NCOM-7$;
endif;
if ('$DIALOGbutton$' = 'Cancel') goto SELECTION;

-- Continue the exploration --
goto VISITER;

-----------------------
label explorer-PRODUIT;
-----------------------
set operation = EXPLORER;
set tableCourante = PRODUIT;

parameter styleGeneralMessage = relief;
if ($exploreColumns$ = 1) parameter styleBoxFrame = relief;
if ($exploreColumns$ = 2) parameter styleBoxFrame = flat;
if ($exploreColumns$ = 1) parameter styleBoxMessage = flat;
if ($exploreColumns$ = 2) parameter styleBoxMessage = relief;
parameter styleEntry = flat;
parameter styleText = flat;

set id = $idPRODUIT$;

-- New or undergoing exploration? --
if ('$id$' = '');
   ask id = [/bExplorer PRODUIT] PRODUIT:[select NPRO from PRODUIT order by NPRO]
   if ('$DIALOGbutton$' = 'Cancel' or '$id$' = '') goto SELECTION;
endif;

-- Extract data from selected PRODUIT row --
extract NPRO,LIBELLE,PRIX,QSTOCK  
        = select NPRO,LIBELLE,PRIX,QSTOCK 
          from PRODUIT 
          where cast(NPRO as char) = 'id';

-- Extract data from referenced rows   --

-- Extract data from referencing rows --
outputOpen -DETAIL-6.var;
select * from DETAIL where cast(NPRO as char) = 'id';
outputAppend console;

-- Empty navigation registers --
set idDETAIL = ;
set idPRODUIT = ;

-- Building the display box --
askCombo [/bEnvironnement de PRODUIT $id$]
         [/y10showData NPRO,LIBELLE,PRIX,QSTOCK = [/bLigne PRODUIT courante] NPRO:|LIBELLE:|PRIX:|QSTOCK:]
         $-sep$[showText -DETAIL-6 = [/b/w0/x48/y6DETAIL rfrenant PRODUIT via (NPRO)]]
         |[ask idDETAIL = Visiter DETAIL:[select cast(NCOM as char)||'-'||cast(NPRO as char) from DETAIL where cast(NPRO as char) = 'id']];
if ('$DIALOGbutton$' = 'Cancel') goto SELECTION;

-- Continue the exploration --
goto VISITER;

