

write-b -- ---------------------------------------------------- --;
write   -- Analyse des donnes des tables d'une base de donnes --;
write   -- Voir annexe 22                                       --;
write-a -- ---------------------------------------------------- --;

set limit = 20;

selectFile db = $dbDirectory$, Base de donnes,db;
if ('$db$' = '') stop;

openDB $db$;
createDictionary;

write Seq      : numro de squence de la colonne;
write Colonne  : nom de la colonne;
write Nb inst  : nombre d'instances de valeurs;
write Nb val   : nombre de valeurs distinctes;
write Nb num   : nombre de valeurs numriques;
write Nb int   : nombre de valeurs entires;
write Nb alpha : nombre de valeurs alphabtiques;
write Nb date  : nombre de dates ;
write Nb null  : nombre de valeurs 'null';
write Nb vide  : nombre de chanes vides;
write Min long : longueur minimum des valeurs;
write Moy long : longueur moyenne des valeurs;
write Max long : longueur maximum des valeurs;
write Min val  : valeur minimum (tronque);
write Max val  : valeur maximum (tronque);
write;

for tid,tab = [select TableID,TableName from SYS_TABLE
               where TableName not like 'SYS_%' order by TableID];
  write-b Statistiques des colonnes de la table $tab$;
  extract ncol = select count(*) from SYS_COLUMN where TableID = $tid$;
  set query = ;
  set I = 0;
  for seq,col = [select ColSeq,ColName from SYS_COLUMN
                 where  TableID = $tid$ order by ColSeq];
    compute I = $I$ + 1;
    set query = $query$ select $seq$ as Seq,'$col$' as Colonne,;
    set query = $query$  count($col$) as "Nb inst",;
    set query = $query$  count(distinct $col$) as "Nb val",;
    set query = $query$  sum(case when isNumeric($col$) then 1 else 0 end) as "Nb num",;
    set query = $query$  sum(case when isInteger($col$) then 1 else 0 end) as "Nb int",;
    set query = $query$  sum(case when isNotNumeric($col$) then 1 else 0 end) as "Nb alpha",;
    set query = $query$  sum(case when isDate($col$) then 1 else 0 end) as "Nb date",;
    set query = $query$  sum(case when $col$ is null then 1 else 0 end) as "Nb null",;
    set query = $query$  sum(case when $col$ = '' then 1 else 0 end) as "Nb vide",;
    set query = $query$  min(length(trim($col$))) as "Min long",;
    set query = $query$  round(avg(length(trim($col$))),1) as "Moy long",;
    set query = $query$  max(length(trim($col$))) as "Max long",;
    set query = $query$  substr(cast(min($col$) as char),1,$limit$) as "Min val",;
    set query = $query$  substr(cast(max($col$) as char),1,$limit$) as "Max val";
    set query = $query$ from $tab$;
    if ($I$ < $ncol$) set query = $query$ union;
  endfor;
  set query = $query$ order by Seq;
  $query$;
endfor;

closeDB;
