-- JLH Septembre 2018 --

write;
write -- ----------------------------------------------------------------------------- --;
write -- RECHERCHE DES DEPENDANCES FONCTIONNELLES D'UNE TABLE SOURCE DE SCHEMA INCONNU --;
write -- Recherche limite aux DF minimales lmentaires (voir chapitre 3)             --;
write -- La prcision est d'autant plus grande que le nombre de lignes est important.  --;
write -- ----------------------------------------------------------------------------- --;

selectOne db = [/bSelectionner une base de donnes  analyser]
                  Standard 1 (15 lignes, 6 col.)|Standard 2 (7 lignes, 6 col.)|... autre;
if ('$DIALOGbutton$' = 'Cancel' or $db$ not in (1,2,3)) stop;

if ($db$ = 1);
  createDB InMemory;
  create table T (CAT varchar(20),REG varchar(20),PIECE varchar(20),
                  CLI varchar(20),STATUT varchar(20),PRIX int);

  insert into T values
  --  CAT,    REG,    PIECE,  CLI,   STATUT,PRIX
     ('F94G','West', 'F94W', 'Davis','B1', 65)  
    ,('F94G','West', 'F94W', 'Jean', 'B1', 65)
    ,('F94G','West', 'F94W', 'Bob',  'B2', 65)
    ,('F94G','West', 'F94W', 'Jane', 'B2', 65)
    ,('F94G','South','F94S', 'Jane', 'B2', 18)
    ,('F94G','North','N94S', 'Davis','B1', 21)
    ,('F94G','East', 'F94W', 'Jean', 'B1', 65)
    ,('F22F','North','N22N', 'Davis','B1', 36)
    ,('F94G','North','N94S', 'Bob',  'B2', 60)
    ,('F94H','East', 'F94E', 'Bob',  'B2', 65)
    ,('F94J','West', 'F94E', 'Bob',  'B2', 65)
    ,('F94H','West', 'F94W', 'Jean', 'B1', 65)
    ,('N03P','West', 'N03W', 'Bob',  'B2', 65)
    ,('N03P','South','N03W', 'Jane', 'B2', 65)
    ,('N03P','North','N03N', 'Jane', 'B2', 65);

   --  Solution (couverture minimale) :
   --
   --  CAT --+
   --         \
   --          +--> PIECE --+
   --         /              \
   --  REG --+                +--> PRIX
   --                        /
   --  CLI -----> STATUT ---+

  set tname = T;
  createDictionary;
endif;

if ($db$ = 2);
  createDB InMemory;
  create table T(A integer,
                 B integer,
                 C integer, 
                 D integer,
                 E integer,
                 F integer);

  insert into T values
     (1,2,3,4,6,1),
     (2,3,4,5,5,1),
     (3,4,5,5,4,1),
     (3,4,6,4,4,2),
     (4,5,7,5,3,2),
     (5,3,2,6,2,2),
     (5,3,1,6,1,3);

  set tname = T;
  createDictionary;
endif;

if ($db$ = 3);
  selectFile db = $dbDirectory$, Base de donnes,db;
  if ('$db$' = '') stop;

  openDB $db$;

  createDictionary;

  ask tname = [/bSlectionner une table] Table:[select TableName from SYS_TABLE
                                                where  TableName not like 'SYS_%'];
  if ('$DIALOGbutton$' = 'Cancel' or '$tname$' = '') stop;
endif;

set d1,d2,d3,d4,d5,d6 = 0,0,0,0,0,1;
selectMany-u d1,d2,d3,d4,d5,d6 =
                      [Selectionner les rsultats  afficher]
                       Contenu de la table source (max 300 lignes)
                      |Combinaisons de colonnes (max 300)
                      |DF candidates (max 300)
                      |DF candidates values (max 300)
                      |DF relles
                      |DF minimales lmentaires;

if ($d1$ = 1);
   write-b -- Contenu de la table source $tname$ --;
   select * from $tname$ #[1,300];
endif;


set NCol = 3;
ask-u NCol = Nombre maximum de colonnes du dterminant;
if ('$DIALOGbutton$' = 'Cancel' or '$NCol$' = '') stop;

extract idT = select TableID from SYS_TABLE where TableName = '$tname$';

create temporary table COMB(List varchar(256),Size integer);


-- Gnration des combinaisons de NCol colonnes --
-- -------------------------------------------- --
with LISTS(List,Last,Size) as
   (select ColName,ColSeq,1 from SYS_COLUMN
    where  TableID = $idT$
      union all
    select L.List||','||S.ColName,S.ColSeq,L.Size + 1 
    from   LISTS L,SYS_COLUMN S
    where  TableID = $idT$
    and    S.ColSeq > L.Last
    and    L.Size < $NCol$)
insert into COMB(List,Size) select List,Size from LISTS;

if ($d2$ = 1);
   write-b -- Gnration des combinaisons de 1  NCol colonnes --;
   select List as Combinaisons from COMB #[1,300];
endif;


-- Gnration des DF candidates --
-- ---------------------------- --
create temp table CAND_DF as
select B.List as Left,Size,C.ColName as Right,0 as Valid
from   COMB B, SYS_COLUMN C
where  C.TableID = $idT$
and    not itemInclude(B.List,C.ColName,',');

if ($d3$ = 1);
   write-b -- Gnration des DF candidates --;
   select Left as Dtermin,Right as Dterminant from CAND_DF #[1,300];
endif;


-- Evaluation des DF candidates --
-- ---------------------------- --
for len = [1,$NCol$];
  for left,lleft,right = [select Left,replace(Left,',','||'),Right
                          from   CAND_DF
                          where  Size = $len$
                          order by Left];
     extract N1 = select count($lleft$) 
                  from   (select distinct $left$,$right$
                          from   '$tname$');
     extract N2 = select count(distinct $lleft$)
                  from   (select distinct $left$,$right$
                          from   '$tname$');
     if ($N1$ = $N2$) update CAND_DF set Valid = 1
                      where  Left = '$left$' and Right = '$right$';
  endfor;
endfor;

if ($d4$ = 1);
   write-b -- Evaluation des DF candidates --;
   select Left as Dtermin,Right as Dterminant,Valid as Valide from CAND_DF #[1,300];
endif;


-- Slection des DF valides --
-- ------------------------- --
delete from CAND_DF where Valid = 0;

if ($d5$ = 1);
   write-b -- Slection des DF valides --;
   select Left as Dtermin,'-->' as '  ',Right as Dterminant from CAND_DF #[1,300];
endif;


-- DF minimales lmentaires --
-- ------------------------- --
if ($d6$ = 1);
   write-b -- DF minimales lmentaires --;
   select Left as Dtermin,'-->' as '  ',Right as Dterminant 
   from   CAND_DF DF
   where  not exists (select *
                      from   CAND_DF
                      where  itemInclude(DF.Left,Left,',')
                      and    Left <> DF.Left
                      and    Right = DF.Right) #[1,300];

   write-b ATTENTION:@n@S2 Il reste  liminer les DF drivables par (pseudo-)transitivit.;
endif;

closeDB;
