-- ---------------------------------------------------------------------------- --
-- Gestion d'un zoo - Procdure principale                                      --
-- ---------------------------------------------------------------------------- --

set dir = $generalDirectory$/Scripts/BD-2022/Chapitre-24;

-- Crer la base de donnes si absente --
-- ----------------------------------- --
onError continue;
if (not fileExists('$dbDirectory$/ZOO.db'));
   showMessage La base de donnes "ZOO.db" n'existe pas.@nVoulez-vous la crer ?;
   if ('$DIALOGbutton$' = 'Cancel') stop;
   execSQL $dir$/_Creer-BD.sql;
endif;

openDB ZOO.db;

set oper = 4;

-- Executer srie d'oprations --
-- --------------------------- --
while (True);
  set buttonYES,buttonNO = Excuter,Terminer;
  selectOne-u oper = [/bGestion d'un zoo (prototype  complter)] 
                  Enregistrer un nouvel animal
                 |Enregistrer une instance de soins
                 |Enregistrer un rgime
                 |Evaluer un rgime
                 |Visualiser les espces
                 |Visualiser les animaux
                 |Visualiser les rgimes;
  if ('$DIALOGbutton$' = '$buttonNO$') set oper = 8;
  
  goto F$oper$;

  label F1;
    execSQL $dir$/_Creer-ANIMAL.sql;
  next;

  label F2;
    execSQL $dir$/_Creer-SOINS.sql;
    next;

  label F3;
    execSQL $dir$/_Creer-REGIME.sql;
    next;

  label F4;
    execSQL $dir$/_Valider-REGIME.sql;
    next;

  label F5;
    select * from ESPECE order by NOM_ESPECE;
    next;

  label F6;
    select * from ANIMAL order by NOM_ESPECE,NOM_ANIMAL;
    next;

  label F7;
    select R.NOM_ANIMAL,R.DATE_REGIME,NOM_INGREDIENT,QUANTITE
    from   REGIME R, COMPOSITION C
    where  (R.NOM_ANIMAL,R.DATE_REGIME) = (C.NOM_ANIMAL,C.DATE_REGIME)
    order by R.NOM_ANIMAL,R.DATE_REGIME,NOM_INGREDIENT;
    next;

  label F8;
    exit;

endwhile;

closeDB;


