-- ----------------------------------- --
-- Display the contents of the tables  --
-- ----------------------------------- --

set defWidth = $maxSelectWidth$;
set maxSelectWidth = 68;

write-b ACCOUNT;
select AccountID,
       PrivName,
       substr(SecretKey,1,15)||'[..]'||substr(SecretKey,-15,15) as SecretKey,
       RecTime
from   ACCOUNT;

write-b DIRECTORY;
select AccountID,
       substr(PublicKey,1,15)||'[..]'||substr(PublicKey,-15,15) as PublicKey,
       Miner
from   DIRECTORY;

write-b BTRANSACTION;
select TransKey,
       TransID,
       Bhash,
       Operation,
       Source,
       Recip,
       Amount,
       RecTime,
       substr(Signature,1,15)||'[..]'||substr(Signature,-15,15) as Signature
from   BTRANSACTION;

write-b BTRANSACTION_PRIV;
select TransKey,
       substr(TransID,1,10)||'[..]'||substr(TransID,-10,10) as TransID,
       Bhash,
       Operation,
       Source,
       Recip,
       Amount,
       RecTime,
       substr(Signature,1,10)||'[..]'||substr(Signature,-10,10) as Signature
from   BTRANSACTION_PRIV;

set maxSelectWidth = $defWidth$;

return;
