-- ------------------- --
-- Execute a transfer  --
-- ------------------- --

openDB BLOCK_CHAIN.db;

extract NC = select count(*) from ACCOUNT;
if ($NC$ = 0);
   showMessage No account has been registered yet.@nOperation cancelled.;
   goto END;
endif;

ask source,recip,amount = [/bEnter the transfer data]
          Your name:[!select PrivName,AccountID from ACCOUNT order by PrivName]
         |Recipient name:[!select PrivName,AccountID from ACCOUNT order by PrivName]
         |Amount to transfer:;
if ('$DIALOGbutton$' = 'Cancel') goto END;

if ('$source$' = '' or '$recip$' = '' or '$amount$' = '' or isNotNumeric('$amount$'));
   showMessage Incorrect data.;
   goto END;
endif;

if ($amount$ <= 0);
   showMessage Incorect amount;
   goto END;
endif;

if ('$source$' = '$recip$');
   showMessage You cannot transfer money to yourself.;
   goto END;
endif;

extract secretKey = select SecretKey from ACCOUNT where AccountID = '$source$';

set      recTime   = $dateclock$;
set      transID   = $source$-$date$_$clock$;
set      operation = TRANSFER;
function signature = LStr:encryptRSA {$transID$;$operation$;$source$;$recip$;$amount$;$recTime$},
                                     {$secretKey$};

extract plusD = select coalesce(sum(Amount),0) from BTRANSACTION
                where  operation = 'DEPOSIT' and Recip = '$source$';
extract plusT = select coalesce(sum(Amount),0) from BTRANSACTION
                where  operation = 'TRANSFER' and Recip = '$source$';
extract minus = select coalesce(sum(Amount),0) from BTRANSACTION
                where  operation = 'TRANSFER' and Source = '$source$';
compute balance = $plusD$ + $plusT$ - $minus$;

if ($balance$ < $amount$);
   showMessage Insufficient balance.@nOperation cancelled.;
   goto END;
endif;

insert into BTRANSACTION (TransID,Operation,Source,Recip,Amount,RecTime,Signature)
       values ('$transID$','$operation$','$source$','$recip$',$amount$,'$recTime$','$signature$');
commitDB;

if ($showData$) execSQL $path$/_BC_Display_tables.sql;

label END;

closeDB;

return;
