-- --------------------------------- --
-- DIRECTORY MANAGEMENT AND ANALYSIS --
--           Main program            --
--     J-L Hainaut, August 2017       --
-- --------------------------------- --

-- Local directory              --
set sourceDir = $scriptDirectory$/Case-Studies/Case_Directory_Management;

-- Load common query patterns   --
execSQL $sourceDir$/_DIR-Common-Patterns.sql;

-- Set special parameter values --
   set curEntryWidth2 = $entryWidth2$;
   set entryWidth2 = 64;
   set curMaxSelectWidth = $maxSelectWidth$;
   set maxSelectWidth = 80;

-- List of module names         --
   set modList =           Create-or-Replace;
   set modList = $modList$;Load-Instance;
   set modList = $modList$;Load-Hash;
   set modList = $modList$;Delete-Directory;
   set modList = $modList$;Delete-Instance;
   set modList = $modList$;Help;
   set modList = $modList$;General-Statistics;
   set modList = $modList$;Structure-Instance;
   set modList = $modList$;Contents-Instance;
   set modList = $modList$;List-Duplicates-1;
   set modList = $modList$;Describe-Duplicates-1;
   set modList = $modList$;Compare-2-Instances;
   set modList = $modList$;Select-Clone-Candidates-1;
   set modList = $modList$;Select-Clone-Candidates-2;

set op = 2;

while (True);
   selectOne-u op = [/b @t            DIRECTORY MANAGEMENT AND ANALYSIS]
                              {Directory management}
                              | Create or replace DIRECTORY database
                              | Load a Directory instance
                              | Load hash values of a Directory instance
                              | Delete a Directory
                              | Delete a Directory Instance
                              | Help
                             || {Directory analysis}
                              | Statistics
                              | Structure of a Directory instance (folders) 
                              | Contents of a Directory instance (folders and files)
                              | List duplicates within a Directory instance
                              | Describe duplicates within a Directory instance
                              | Compare two Directory instances
                              | Finding clones within one Directory instance
                              | Finding clones within two Directory instance;

   if ('$DIALOGbutton$' = 'Cancel') exit;

   -- Execute selected module --
   compute module = itemS('$modList$',$op$);
   execSQL $sourceDir$/_DIR-$module$.sql;

endwhile;

-- Restore standard values    --
   set maxSelectWidth = 60;
   set entryWidth2 = $curEntryWidth2$;
   set maxSelectWidth = $curMaxSelectWidth$;

closeHelp;

stop;
