-- ----------------------------------- --
-- Examine the contents of an instance --
-- ----------------------------------- --

if (not fileExists('dbDirectory/DIRECTORY.db'));
   showMessage Database "DIRECTORY.db" not found;
   return;
endif;

openDB DIRECTORY.db;

ask inst,ext = Instance:[!$listInstances$]
              |Type:[!$listTypes$];
if ('$DIALOGbutton$' <> 'OK' or '$inst$' = '') goto EXIT;

if (startswith('$ext$','*.'));
    selectOne stru = [/bWould you like directory names as well?]
                                               No, just file names
                                              |Yes print also directory names;
    if ('$DIALOGbutton$' <> 'OK' or $stru$ = 0) goto EXIT;
endif;

if ('$ext$' = '') set ext = all files and directories;

set extCond = ;
if ('$ext$' = 'all files and directories') set extCond = ;
if ('$ext$' = 'all files')                 set extCond = and NType = 'F';
if ('$ext$' = 'all directories')           set extCond = and NType = 'D';
if (startswith('$ext$','*.'));
   if ($stru$ = 1);
      -- No directory names
      set extCond = and Extension = substr('ext',3,99);
   else;
      -- With directory names
      set extCond = and (Extension = substr('ext',3,99) or NType = 'D');
   endif;
endif;

set style = 2;
selectOne-u style = [/bSelect the output format]
                  Full tabular format|Short format (names only);
if ('$DIALOGbutton$' = 'Cancel') goto EXIT;

if ($style$ = 1) goto FULL;
if ($style$ = 2) goto SHORT;

label FULL;
-- -------
extract iName = $instName$;
write-ab -- Contents ($ext$) of Directory instance "$iName$" --;

select NodeID as Node,
       repeat('.... ',Level)
     ||case when NType = 'F'
            then LocalName
            else '['||LocalName||']'
       end as Name,
       Prefix as Source
from NODE
where InstID = $inst$ $extCond$
order by Path;
goto EXIT;

label SHORT;
-- --------
parameter select-align = N;
set bar11 = ;
set bar21 = ;
set bar31 = ;
set bar14 = @n;
set bar24 = @n;
set bar34 = @n;
set data1 = ;
set data4 = @n;
set data1 = ;
set head1 = ;
set head2 = ;
set head3 = ;
set head4 = ;
select repeat('.... ',Level)
     ||case when NType = 'F'
            then LocalName
            else '['||LocalName||']'
       end as Name
from NODE
where InstID = $inst$ $extCond$
order by Path;

execSQL UTIL-SELECT-parameters-standard-1.sql;
goto EXIT;

label EXIT;
   closeDB;

return;