-- -------------------------------------------- --
-- Identify clone candidates within an instance --
-- -------------------------------------------- --

if (not fileExists('dbDirectory/DIRECTORY.db'));
   showMessage Database "DIRECTORY.db" not found;
   return;
endif;

openDB DIRECTORY.db;

set inst = ;
ask-u inst = Instance:[!$listInstances$];
if ('$DIALOGbutton$' = 'Cancel' or '$inst$' = '') goto EXIT;

extract iName = $instName$;
write-ab -- List of clone files in Directory instance "$iName$" --;

select Hash as "Clone group",LocalName as Clone,Prefix as Source
from (select $hashDigest$ as "Hash",'' as LocalName,'' as Prefix,Hash||'C' as Sort
      from   ($cloneHash$)
         union 
      select '' as "Hash",LocalName,Prefix,Hash||'F' as Sort
      from   NODE where Hash in ($cloneHash$) and InstID = $inst$)
order by Sort;

label EXIT;
   closeDB;

return;
