set sourceDir = $scriptDirectory$/Case-Studies/Case_Kings_of_France;

selectOne task = [/b@S8KINGS OF FRANCE: select a chapter] 
               {Create KINGS database}
                |Create and load KINGS database
               |{Simple queries}
                |Simple queries
               |{Recursive queries}
                |Closure of MEMBER
                |Extended closure of MEMBER
                |Querying the closure
                |Counting descendants
               |{Graphical representation}
                |Indented list of descendants
                |Drawing simple tree of members
                |Drawing improved tree of members
                |Drawing improved tree of kings;

if ('$DIALOGbutton$' = 'Cancel') stop;

if ($task$ = 1) execSQL $sourceDir$/_createKINGS.sql;

if ($task$ = 2) execSQL $sourceDir$/_KING-Simple-queries.sql;

if ($task$ = 3) execSQL $sourceDir$/_KING-10-Pure-closure.sql;
if ($task$ = 4) execSQL $sourceDir$/_KING-11-Extended-closure.sql;
if ($task$ = 5) execSQL $sourceDir$/_KING-13-Querying-the-closure.sql;
if ($task$ = 6) execSQL $sourceDir$/_KING-15-Counting-Descendants.sql;

if ($task$ = 7) execSQL $sourceDir$/_KING-16-Indented list.sql;
if ($task$ = 8) execSQL $sourceDir$/_KING-18-Members-Simple-Drawing.sql;
if ($task$ = 9) execSQL $sourceDir$/_KING-20-Members-Full-Drawing.sql;
if ($task$ = 10) execSQL $sourceDir$/_KING-23-King-Full-Drawing.sql;

stop;
