
openDB KINGS.db;

set Closure = select Father,PiD,1,'.'||Father||'.'||PiD||'.'
              from MEMBER where Father is not null
                 union all
              select P.Ancestor,M.PiD,P.Len+1,P.Path||M.PiD||'.'
              from   CTE_PATHS P,MEMBER M
              where  P.Descendant = M.Father;

create temporary view PATHS as
with recursive CTE_PATHS(Ancestor,Descendant,Len,Path) as
($Closure$)
select Ancestor,Descendant,Len,Path
from   CTE_PATHS;

-- =========================================== --

-- Number of descendants of monarchs --
select Ancestor, count(*) as Descend 
from   PATHS group by Ancestor
   union
select PiD as Ancestor, 0 as Descend
from   MEMBER
where  PiD not in (select Ancestor from PATHS)
order by Descend desc,Ancestor;

-- The same, with additional information --

select '['||Ancestor||'] '||K.Name||', King of France, has '
      ||Descend||' royal descendants'
from KING K,
     (select Ancestor, count(*) as Descend 
      from   PATHS
      where  Descendant in (select PiD from KING)
      group by Ancestor
         union
      select PiD as Ancestor, 0 as Descend
      from   MEMBER
      where  PID not in (select Ancestor from PATHS)) DC
where DC.Ancestor = K.PiD
order by Descend desc,Ancestor;

closeDB;
