
-- ----------------------------------- --
-- Draw the KING hierarchy (version 1) -- 
-- ----------------------------------- --

onError stop;

openDB KINGS.db;

set entryWidth = 40;
set maxSelectWidth = 10000;

set pid = C00;
ask-u pid = Member:[!select PiD||'-'||Name||','||Title,PiD
                     from   MEMBER order by PiD];
   if ('$DIALOGbutton$' = 'Cancel') return;

extract Nam,Tit = select Name,Title 
                  from   MEMBER where PiD = '$pid$';

set Closure = select 0,'$pid$',PiD,'.'||'$pid$'||'.'||PiD||'.'
              from   MEMBER where Father = '$pid$'
                 union all
              select P.Len+1,P.PID,M.PiD,P.Path||M.PiD||'.'
              from   PATHS P,MEMBER M
              where  P.PiD = M.Father;

create temporary view TREE(Len,Father,PiD,Path) as
   with recursive PATHS(Len,Father,PiD,Path) as ($Closure$)
   select * from PATHS;

select * from TREE order by Path;

execSQL UTIL-SELECT-parameters-for-Lists.sql;

outputOpen draw.var;

-- some shorthands --
-- --------------- --
set maxX = max((Len+1)*10);
set maxY = max((select count(1) from TREE T2
                where  T2.Path < T.Path)*15)+10;

set coordX = cast((Len+1)*10 as char);
set coordY = cast((select count(1) from TREE T2
                   where  T2.Path < T.Path)*15+10  as char);

set header68 = 'points " ",1,"black","black",68@n';
set point68  = $coordX$||','||$coordY$||',"'||M.Name||', '||M.Title||'"@n';
set header31 = 'points " ",1,"black","black",31@n';
set point31  = $coordX$||','||$coordY$||',""';

-- generate "area" directive --
-- ------------------------- --
select 'area '||cast($maxX$+200 as char)||','
              ||cast($maxY$+50 as char) as Area
from TREE T;

-- generate points --
-- --------------- --
select $header68$||$point68$||$header31$||$point31$
from   TREE T,MEMBER M
where  T.PiD = M.PiD
order by Path;

-- store drawing in file KINGdrawing.draw --
-- -------------------------------------- --
outputOpen $fileDirectory$/KINGdrawing.draw;
write $draw$;
outputAppend window;

execSQL UTIL-SELECT-parameters-standard-1.sql;

-- display drawing --
-- --------------- --
showDrawing $fileDirectory$/KINGdrawing.draw
            = [/x450/y700/bDescend of $Nam$, $Tit$];

closeDB;



