
-- ----------------------------------- --
-- Draw the KING hierarchy (version 2) --
-- ----------------------------------- --

onError stop;

openDB KINGS.db;

set entryWidth = 40;
set maxSelectWidth = 10000;

set pid = C00;
ask-u pid = Member:[!select PID||'-'||Name||','||Title,PiD
                     from MEMBER order by PiD];
   if ('$DIALOGbutton$' = 'Cancel') return;

extract Nam,Tit = select Name,Title 
                  from   MEMBER where PID = '$pid$';

set Closure = select 0,'$pid$',PID,'.'||'$pid$'||'.'||PiD||'.'
              from   MEMBER
              where Father = '$pid$'
                 union all
              select P.Len+1,P.PiD,M.PiD,P.Path||M.PiD||'.'
              from   PATHS P,MEMBER M
              where  P.PiD = M.Father;

-- create table TREE --
-- ----------------- --
create temp table TREE (Seq integer primary key autoincrement,
                         Len integer,Father char(6),
                         PID char(6),Path varchar(1024),
                         X integer,Y integer,FX integer,FY integer);

with recursive PATHS(Len,Father,PiD,Path) as ($Closure$)
insert into TREE (Len,Father,PID,Path,X)
select Len+1,Father,PID,Path,(Len+1)*10
from   PATHS order by Path;
-- "order by Path" is necessary to generate monotonic "seq" values --

update TREE 
set Y = Seq*15 - 5,
    FX = (select T.X          from TREE T where T.PiD = TREE.Father),
    FY = (select T.Seq*15 - 5 from TREE T where T.PiD = TREE.Father);

--select * from TREE order by Path;

extract maxX,maxY = select max(X)+320,max(Y)+40 from TREE;

-- start generation --
-- ---------------- --
execSQL UTIL-SELECT-parameters-for-Lists.sql;
outputOpen draw.var;


-- generate SQLdraw script --
-- ------------------------ --

start-timer;

write area $maxX$,$maxY$;
select case when M.Title = 'Roi de France'
            then 'points " ",1,"black","blue",68@n'
            else 'points " ",1,"black","black",68@n'
       end
     ||cast(X as char)||','||cast(Y as char)||',"'
                      ||M.Name||', '||M.Title
                      ||' ('||M.DateBirth||'-'||M.DateDeath||')'
                      ||case when M.Title = 'Roi de France'
                             then ' ('||M.DateReignBegin||'-'||M.DateReignEnd||')"@n'
                             else '"@n'
                        end
     ||case when M.Title = 'Roi de France'
            then 'points " ",1,"blue","black",31@n'
            else 'points " ",1,"black","black",31@n'
       end
     ||cast(X as char)||','||cast(Y as char)||',""'
     ||case when T.FX is null then '' 
            else '@n'
                ||'polyline " ",1,"black",""@n'
                ||cast(FX as char)||','||cast(FY as char)||',""@n'
                ||cast(FX as char)||','||cast(Y as char) ||',""@n'
                ||cast(X as char) ||','||cast(Y as char) ||',""'
       end 
from   TREE T,MEMBER M
where  T.PiD = M.PiD
order by Path;

-- store drawing in file KINGdrawing.draw --
-- -------------------------------------- --
outputOpen $fileDirectory$/KINGdrawing.draw;
write $draw$;
outputAppend console;

write Computing time: $timer$;

execSQL UTIL-SELECT-parameters-standard-1.sql;


-- display drawing --
-- --------------- --
showDrawing $fileDirectory$/KINGdrawing.draw
            = [/x550/y750/bDescend of $Nam$, $Tit$];

closeDB;

stop;
