
openDB KINGS.db;
while (True);
   selectOne query = []
                    How many kings in each house?
                   |How old were kings when ascending the throne?
                   |How long do kings live and reign?
                   |Associating his sons with each father
                   |Associating his sons with each member
                   |Showing the father-son family composition
                   |Brotherhood 
                   |How old were kings when they had their first son?
                   |Missing kings
                   |Royal conflicts: identifying overlapping periods;
    if ('$DIALOGbutton$' = 'Cancel' or $query$ = 0) exit;

  goto KING-$query$;

  label NEXT;
endwhile;

closeDB;
return;


-- KING-1: How many kings in each house? --
label KING-1;
   write-b -- How many kings in each house? --;
   select House,count(*) as Kings from MEMBER
   where Title = 'Roi de France'
   group by House
   order by count(*) desc;
goto NEXT;

-- KING-2: How old (on the average) were kings when ascending the throne? --
label KING-2;
   write-b -- How old (on the average) were kings when ascending the throne? --;
   select round(avg(DateReignBegin - DateBirth),1) as Beginning_reign_age
   from   KING;
goto NEXT;


-- KING-3: How long do kings live and reign? --
label KING-3;
   write-b -- How long do kings live and reign? --;
   set life = DateDeath - DateBirth;
   set reign = DateReignEnd - DateReignBegin;
   select min($life$)           as MinLife,
          round(avg($life$),1)  as AvgLife,
          max($life$)           as MaxLife,
          min($reign$)          as MinReign,
          round(avg($reign$),1) as AvgReign,
          max($reign$)          as MaxReign
   from KING
   where DateBirth < DateDeath;
goto NEXT;


-- KING-4: Associating his sons with each father --
label KING-4;
   write-b -- Associating his sons with each father --;
   select Father,group_concat(PiD,',') as Sons
   from   MEMBER
   group by Father;
goto NEXT;


-- KING-5: Associating his sons with each member --
label KING-5;
   write-b -- Associating his sons with each member --;
   select PiD, (select group_concat(PiD,',') 
                from  MEMBER
                where Father = M.PiD) as Sons
   from   MEMBER M;
goto NEXT;


-- KING-6: Showing the father-son family composition --
label KING-6;
   write-b -- Showing the father-son family composition --;
   set birth = ' ('||cast(DateBirth as text)||')';
   select (select Name||$birth$ from MEMBER 
           where PiD = M.Father)           as Father,
           group_concat(Name||$birth$,',') as Sons
   from   MEMBER M
   group by Father;
goto NEXT;


-- KING-7: Brotherhood --
label KING-7;
   write-b -- Brotherhood --;
   select group_concat(Name||$birth$,',') as Brothers
   from   MEMBER
   group by Father
   having count(*) > 1;
goto NEXT;


-- KING-8: How old were kings when they had their first son? --
label KING-8;
   write-b -- How old were kings when they had their first son? --;
   select F.Name||' ('||cast(F.DateBirth as text)||')' as Father,
          count(*)                                     as Sons,
          min(S.DateBirth - F.DateBirth)               as AgeFirstSon
   from   MEMBER F, MEMBER S
   where  F.PiD = S.Father
   group by F.PiD,F.Name
   order by AgeFirstSon;
goto NEXT;


-- KING-9: Missing kings --
label KING-9;
    write-b -- Missing kings --;
  select K1.Name            as Last_king,
          K1.DateReignEnd   as "From",
          K3.DateReignBegin as "To",
          K3.Name           as Next_king
   from   KING K1, KING K3
   where  K1.DateReignEnd < K3.DateReignBegin
   and not exists(select 1 from KING K2 
                  where  K2.DateReignEnd <= K3.DateReignBegin
                  and    K1.DateReignEnd <= K2.DateReignBegin);
goto NEXT;


-- KING-10: Royal conflicts: identifying overlapping periods --
label KING-10;
   write-b -- Royal conflicts: identifying overlapping periods --;
   select K1.Name as First_king,
          K2.Name as Second_king
   from   KING K1, KING K2
   where  K1.PiD <> K2.PiD
   and    K1.DateReignEnd > K2.DateReignBegin
   and    K2.DateReignEnd > K1.DateReignBegin
   order by K1.Name,K2.Name;
goto NEXT;


