-- ---------------------------------- --
-- Compile game "game" and play it    --
-- ---------------------------------- --

-- Create the database and its tables                                 --
-- ------------------------------------------------------------------ --
   write-b -- Compilation of $game$ started --;
   start-timer;
execSQL $sourceDir$/_LIFE-create-Database.sql;
   write --   Database created in $timer$ s.;

-- Create a $maxLin$ X $maxCol$ world                                 --
-- ------------------------------------------------------------------ --
   start-timer;
execSQL $sourceDir$/_LIFE-create-World.sql;
   write --   World created in $timer$ s.;

-- Load 1st generation of the selected game                           --
-- ------------------------------------------------------------------ --
set Lnbr,Cnbr,Niter,Delay = 0,0,0,0;
   start-timer;
execSQL $sourceDir$/Create-LIFEGAME-$game$.sql;
   write --   Game initialized in $timer$ s.;

-- If parameters not completely initialized in the game, ask the user --
-- ------------------------------------------------------------------ --
if ($Lnbr$*$Cnbr$*$Niter$*$Delay$ = 0);
   set Lnbr,Cnbr,Niter,Delay = 16,16,40,150;
   ask-u Lnbr,Cnbr,Niter,Delay = 
                [LIFE GAME simulation parameters] 
                Lines:|Columns:|Iterations:|Delay (ms):;
   if ('$DIALOGbutton$' = 'Cancel') return;
endif;

-- Go on ...                                                          --
-- ------------------------------------------------------------------ --
   start-timer;
execSQL $sourceDir$/_LIFE-compute-History.sql;
   write --   $Niter$ generations compiled in $timer$ s. --;
