-- ------------------------------------------------ --
-- Get parameters of the current session            --
-- ------------------------------------------------ --

-- default values      --
-- ------------------- --
set xCat,xLev = ,1;
set textw,texth1,texth2 = 80,6,20;
set help = 0;

openDB SQLtutor.db;

while (True);
   askCombo [/b@S35SPECIFYING THE SESSION]
            [ask-u xCat,xLev
                 = [/bExercises of the session]
                    Category:[select distinct Category 
                              from   EXERCISE order by Category]
                   |Level:[select 'all' as Level
                              union
                           select distinct Level 
                           from   EXERCISE order by Level]]
            |[ask-u textw,texth1,texth2
                 = [/bSize of text areas]
                    Width of text areas:
                   |Height of the query area
                   |Height of the result area]
            |[selectMany help = Display the text of the exercises and the instructions]];
   if ('$DIALOGbutton$' = 'Cancel') exit;

   set levCondition = ;
   if ('$xLev$' <> 'all') set levCondition = and Level = $xLev$;

   extract Nex = select count(*) from EXERCISE where Category = '$xCat$' $levCondition$;
   if ($Nex$ > 0);
      exit;
   else;
      showMessage Sorry. There is no exercise at this level.@nTry a lower level.;
      next;
   endif;
endwhile;


-- Create INDEX, an ordered list of ExID of selected exercises --
-- Needed to get the default "next exercise"                   --
if ('$DIALOGbutton$' = 'OK')
    extract INDEX = select group_concat2(ExID,1,ExID,0,';')
                    from   EXERCISE where Category = '$xCat$' $levCondition$;

closeDB;

-- ---------------------------------------------------------
-- USES
-- ---------------------------------------------------------
--    none
-- ---------------------------------------------------------
-- RETURNS
-- ---------------------------------------------------------
--  - xCat:   Category of the exercise set
--  - xLev:   Level of the exercise set
--  - textw,texth1,texth2
--  - help:   open Help window
--  - levCondition: condition on Level
--  - INDEX:  ordered list of ExID of the selected exercises
--  - DIALOGbutton
-- ---------------------------------------------------------
