-- ---------------------------------- --
-- Let the student select an exercise --
-- ---------------------------------- --

openDB SQLtutor.db;

-- Get info of the default next exercise --
-- ------------------------------------- --
compute curPos   = $curPos$ + 1;
compute curExID  = itemS('$INDEX$',$curPos$);
extract curTitle = select '('||ExID||') '||Title from EXERCISE
                   where  ExID = '$curExID$';

-- -------------------------------------------------------- --
-- INDEX:    ordered list of ExID of the selected exercises --
-- curPos:   index in INDEX of the next ExID to process     --
-- curExID:  next ExID to process                           --
-- curTitle: ExID & Title combination of next exercise      --
-- -------------------------------------------------------- --

-- Define empty dialogue box --
-- ------------------------- --
set xText   = \n              --- SELECT AN EXERCISE THEN CLICK ON "OK" ---;

-- Before "askCombo.ask-u", "xId" is initialized with "curTitle" of the last exercise.
set xId = $curTitle$;

set entryWidth2 = 96;
askCombo [/b SQL Tutor: Learning SQL at your own pace]
         [ask-u xId = [/bCategory "$xCat$", Level $xLev$  -  Select a new exercise]
                      Exercise:[!select '('||ExID||') '||Title,ExID from EXERCISE
                                 where Category = '$xCat$' $levCondition$]]
        |[showText xText   = [/b/y5/x$textw$@S]]
        |[showText xQuery  = [/b/y$texth1$/x$textw$@S]]
        |[showText xResult = [/b/y$texth2$/x$textw$/w0@S]]
        ;
set entryWidth2 = 48;

-- After "askCombo.ask-u", "xId" receives the "ExID" of the next exercise.

if ('$DIALOGbutton$' = 'OK');
   compute curPos = itemIndexS('$INDEX$','$xId$');

   extract xDB,xText,rQuery = select DB,ProblemText,
                                case when $encode$ = 1
                                     then b64decode(RefQuery)
                                     else RefQuery
                                end
                              from   EXERCISE where ExID = 'xId';

endif;

closeDB;

-- ---------------------------------------------------------
-- USES
-- ---------------------------------------------------------
--  - INDEX:  ordered list of ExID of the selected exercises
--  - curPos: index in INDEX of the current ExID
--  - xCat:   Category of the current exercise set
--  - xLev:   Level of the current exercise set
--  - levCondition: condition on Level
--  - xText:  text of the current exercise
--  - xQuery: student's query
--  - xResult: current contents of the result area
--  - texth1, texth2, textw
--  - encode: classified!
-- ---------------------------------------------------------
-- RETURNS
-- ---------------------------------------------------------
--  - xId:    ExID of the next exercise selected bu the student
--  - xDB:    DB name of the current exercise
--  - xText:  text of the current exercise
--  - rQuery: reference query of the current exercise
--  - curPos: index in INDEX of the next ExID
--  - DIALOGbutton
-- ---------------------------------------------------------
-- INTERNAL
-- ---------------------------------------------------------
--  - curExID:  ExID of the default next exercise in INDEX
--  - curTitle: ExID & Title combination of default next exercise in INDEX
-- ---------------------------------------------------------
