-- -------------------------- --
-- Inter-City_Solver.sql --
-- -------------------------- --

write-b -- ------------------------------------------- --;
write   -- The map is created as a user-defined matrix --;
write   -- ------------------------------------------- --;

-- Do we want the final state of table NODE be displayed --
set displayGRAPH = 1;
set displayNODE  = 1;

createDB InMemory;

-- Create the model database --
execSQL $sourceDir$/__Shortest-path_DB.sql;

-- Load an inter-city map  --
-- ----------------------- --
execSQL $sourceDir$/_Large-grid-maps_Loader.sql;

-- Display table GRAPH --
-- ------------------ --
if ($displayGRAPH$) execSQL $sourceDir$/__Display_Graph.sql;

-- Select starting and target nodes --
-- -------------------------------- --
set start = ;
set end = ;
ask start,end = Starting node:[!select Name,NodeID from NODE order by Name]
               |Target node:[!select Name,NodeID from NODE order by Name];
   if ('$DIALOGbutton$' = 'Cancel' or '$start$' = '') stop;

-- Initialize the starting node --
-- ---------------------------- --
update NODE set Mark = 0, Cost = 0, Path = Name where NodeID = '$start$';

-- Solve the shortest path model --
-- ----------------------------- --
execSQL $sourceDir$/__Shortest-path_Engine.sql;

-- Display the shortest path --
-- ------------------------- --
execSQL $sourceDir$/__Display_Shortest-path.sql;

-- Display table NODE --
-- ------------------ --
if ($displayNODE$) execSQL $sourceDir$/__Display_Nodes.sql

closeDB;
