-- -------------------------- --
-- Rover-on-Planet_Solver.sql --
-- -------------------------- --

-- Do we want the final state of table NODE be displayed --
set displayNODE = 1;

-- ----------------------------------------------------- --

createDB InMemory;

-- Create the model database --
execSQL $sourceDir$/__Shortest-path_DB.sql;

-- Get the robot power consumption parameters --
-- ------------------------------------------ --
set c1 = 1;
set c2 = 3;
set c3 = 999999;
ask-u c1,c2,c3 = Cost of normal step:|Cost of swamp step:|Cost of rock step:;

-- Load the planet model  --
-- --------------------- --
execSQL $sourceDir$/_Rover-on-Planet_Loader.sql;

-- Select starting and target nodes --
-- -------------------------------- --
set start = ;
set end = ;
ask start,end = Starting node:[select Name,NodeID from NODE order by Name]
               |Target node:[select Name,NodeID from NODE order by Name];
   if ('$DIALOGbutton$' = 'Cancel' or '$start$' = '') stop;

-- Initialize the starting node --
-- ---------------------------- --
update NODE set Mark = 0, Cost = 0, Path = Name where NodeID = '$start$';

-- Solve the shortest path model --
-- ----------------------------- --
execSQL $sourceDir$/__Shortest-path_Engine.sql;

-- Display the shortest path --
-- ------------------------- --
execSQL $sourceDir$/__Display_Shortest-path.sql;

-- Display table NODE --
-- ------------------ --
if ($displayNODE$) execSQL $sourceDir$/__Display_Nodes.sql

closeDB;
