-- ---------------------------------------- --
-- CREATE LIBRARY database (proto version)  --
-- ---------------------------------------- --

parameter commitmode  = autocommit;

createOrReplaceDB LIBRARY-proto.db;

create table BOOK(
   BookID     varchar(32) not null primary key,
   Title      varchar(96) not null,
   Collection varchar(32),
   Authors    varchar(64),
   Publisher  varchar(32)
);

create table READER(
   ReaderID   varchar(32) not null primary key,
   RegDate    char(24)    not null,
   Name       varchar(48) not null,
   Address    varchar(64)
);

create table BORROW(
   BookID     varchar(32) not null,
   ReaderID   varchar(32) not null,
   BorrowDate date not null,
   ReturnDate date,
   primary key (BookID,BorrowDate)
);

insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01086','Little Nemo in Slumberland Vol. 1','Integrale','W. McCay','Nostalgia Press');
insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01125','Little Nemo 1905-1914','2000 Series','W. McCay','Taschen');
insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01196','Lizard Queen','Blackhole','Ch. Burns','Fantagraphics');
insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01208','Little Nemo in Slumberland Vol. 2','Integrale','W. McCay','Nostalgia Press');
insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01261','The Castafiore Emerald','The adventure of Tintin','Herg','Methuen Children''s books');
insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01377','The revenge of the baby-sat','Calvin and Hobbes','Watterson','Andrews and McMeel');
insert into BOOK(BookID,Title,Collection,Authors,Publisher)
   values('B.01480','Yukon Ho!','Calvin and Hobbes','Watterson','Andrews and McMeel');

insert into READER(ReaderID,RegDate,Name,Address)
   values('R.0538','2016-11-13','SMITH Bernard','Place Bockstael, Bruxelles');
insert into READER(ReaderID,RegDate,Name,Address)
   values('R.0572','2016-11-21','JONES F. J.',  '108, Sq de Meeus, Bruxelles');
insert into READER(ReaderID,RegDate,Name,Address)
   values('R.0660','2016-12-05','BIN YAO F.',   '37, Blv Hausman, Paris');
insert into READER(ReaderID,RegDate,Name,Address)
   values('R.0668','2016-12-21','TRAVIS K. K.', '9, Rue H. Stockel, Bruxelles');
insert into READER(ReaderID,RegDate,Name,Address)
   values('R.0781','2017-01-12','MASRI R.',     '374, Av Vermont, Paris');
insert into READER(ReaderID,RegDate,Name,Address)
   values('R.0838','2017-02-18','DAENINCKX, Daniel','37, Av de la Magne, Paris');

insert into BORROW(BookID,ReaderID,BorrowDate) values('B.01086','R.0572','2017-05-20');
insert into BORROW(BookID,ReaderID,BorrowDate) values('B.01196','R.0668','2017-05-20');
insert into BORROW(BookID,ReaderID,BorrowDate) values('B.01208','R.0668','2017-05-26');

insert into BORROW(BookID,ReaderID,BorrowDate,ReturnDate)
   values('B.01196','R.0668','2017-05-01','2017-05-08');
insert into BORROW(BookID,ReaderID,BorrowDate,ReturnDate)
   values('B.01196','R.0538','2017-05-08','2017-05-14');
insert into BORROW(BookID,ReaderID,BorrowDate,ReturnDate)
   values('B.01377','R.0538','2017-05-10','2017-05-14');

closeDB;