set sourceDir = $scriptDirectory$/Case-Studies/Case_Temporal_DB;

while (True);
   selectOne task = [/b@S90TEMPORAL DATABASE WORKBENCH] 
                   {Create a temporal database}
                   |Entity-based (transaction) 
                   |Entity-based (valid)
                   |Entity-based (valid with Log)
                   |{Other models}
                   |Attribute-based (transaction) 
                   |Event-based (transaction) 
                   |Event-based (valid)
                   |Document-oriented (transaction)
                  ||{Query a temporal database}
                   |Querying current states 
                   |Temporal queries - non-temporal result 
                   |Temporal queries - temporal result
                   |Temporal projection
                   |Temporal inner join
                   |Temporal outer join
                   |Temporal aggregation: counting
                   |Temporal aggregation: min,max,avg,sum
                   |Temporal aggregation: non partitionned
                   |Temporal aggregation: fixed interval
                  ||{Performance evaluation and optimization}
                   |Querying current states
                   |Temporal queries - non-temporal result 
                   |Temporal queries - temporal result
                   |Temporal projection
                   |Temporal aggregation: counting
                   |Temporal aggregation: min,max,avg,sum
                   |Temporal aggregation: non partionned
                   |Temporal aggregation: fixed interval;

   if ('$DIALOGbutton$' = 'Cancel') exit;

   if ($task$ = 1) execSQL $sourceDir$/_TDB1-Create-Transact-DB.sql;
   if ($task$ = 2) execSQL $sourceDir$/_TDB1-Create-Valid-DB.sql;
   if ($task$ = 3) execSQL $sourceDir$/_TDB1-Create-Valid-DB-with-Log.sql;
   if ($task$ = 4) execSQL $sourceDir$/_TDB1-Create-Transact-Attribute-DB.sql;
   if ($task$ = 5) execSQL $sourceDir$/_TDB1-Create-Transact-Event-DB.sql;
   if ($task$ = 6) execSQL $sourceDir$/_TDB1-Create-Valid-Event-DB.sql;
   if ($task$ = 7) execSQL $sourceDir$/_TDB1-Create-Transact-Document_db.sql;

   if ($task$ = 8)  execSQL $sourceDir$/_TDB2-Query-Current-states.sql;
   if ($task$ = 9)  execSQL $sourceDir$/_TDB2-Query-Simple-Temporal-non-Temporal.sql;
   if ($task$ = 10) execSQL $sourceDir$/_TDB2-Query-Simple-Temporal-Temporal.sql;
   if ($task$ = 11) execSQL $sourceDir$/_TDB2-Query-Temporal-Projection.sql;
   if ($task$ = 12) execSQL $sourceDir$/_TDB2-Query-Temporal-Join.sql;
   if ($task$ = 13) execSQL $sourceDir$/_TDB2-Query-Temporal-Outer-Join.sql;
   if ($task$ = 14) execSQL $sourceDir$/_TDB2-Query-Temporal-Aggregation-count.sql;
   if ($task$ = 15) execSQL $sourceDir$/_TDB2-Query-Temporal-Aggregation-min-max-avg-sum.sql;
   if ($task$ = 16) execSQL $sourceDir$/_TDB2-Query-Temporal-Aggregation-No-Partition.sql;
   if ($task$ = 17) execSQL $sourceDir$/_TDB2-Query-Temporal-Aggregation-Fixed-interval.sql;

   if ($task$ = 18) execSQL $sourceDir$/_TDB3-Perf-Current-states.sql;
   if ($task$ = 19) execSQL $sourceDir$/_TDB3-Perf-non-Temporal.sql;
   if ($task$ = 20) execSQL $sourceDir$/_TDB3-Perf-Temporal.sql;
   if ($task$ = 21) execSQL $sourceDir$/_TDB3-Perf-Projection.sql;
   if ($task$ = 22) execSQL $sourceDir$/_TDB3-Perf-Aggreg-count.sql;
   if ($task$ = 23) execSQL $sourceDir$/_TDB3-Perf-Aggreg-min-max-avg-sum.sql;
   if ($task$ = 24) execSQL $sourceDir$/_TDB3-Perf-Aggreg-No-Partition.sql;
   if ($task$ = 25) execSQL $sourceDir$/_TDB3-Perf-Aggreg-Fixed-interval.sql;

endwhile;

stop;
