write-b -- ---------------------------------------------------------- --;
write   -- TEMPORAL QUERIES - NON-TEMPORAL RESULT                     --;
write   -- Applicable to valid time database only                     --;
write-a -- ---------------------------------------------------------- --;

openDB TDB.db;

-- H_EMPLOYEE must be non-empty and valid-time. --
-- -------------------------------------------- --

extract N = select count(*) from H_EMPLOYEE;
if ($N$ > 0);
   extract T = select typeof(start) from H_EMPLOYEE limit 1;
   if ('$T$' <> 'char');
      showMessage WARNING:
                  @n@S3TDB.db is not a valid time database.
                  @n@S3Operation aborted.;
      closeDB;
      return;
   endif;
else;
   showMessage Database empty.@nOperation aborted.;
   closeDB;
   return;
endif;


write-b -- Show the state of employee D107 on 2017-02-01  --;
select CODE,NAME,SALARY,CITY,PROJECT
from   H_EMPLOYEE
where  CODE = 'D107'
and    start <= '2017-02-01'  and '2017-02-01' < end;

write-b -- How many employees were assigned to the SURVEYOR project on 2017-02-01  --;
select count(distinct CODE) as Staff
from   H_EMPLOYEE
where  PROJECT = 'SURVEYOR'
and    start <= '2017-02-01' and '2017-02-01' < end;

write-b -- How many projects has the N240 employee been assigned to during his career? --;
select count(distinct PROJECT) as Projects
from   H_EMPLOYEE
where  CODE = 'N240';

write-b -- How many projects was the M158 employee assigned to while living in Paris? --;
select count(distinct PROJECT) as Projects
from   H_EMPLOYEE
where  CODE = 'M158' and CITY = 'Paris';

write-b -- Which project(s) has employee N240 been assigned to the longest? --;

select PROJECT, sum(durationDays(start,min(end,'$date$'))) as Duration
from   H_EMPLOYEE
where  CODE = 'D107'
group by PROJECT
having Duration = (select sum(durationDays(start,min(end,'$date$'))) as Dur
                   from   H_EMPLOYEE
                   where  CODE = 'D107'
                   group by PROJECT order by Dur desc limit 1);

closeDB;

write-b End of script;

return;
