-- Restore optional links if they do not form circuits --
-- --------------------------------------------------- --

for lid,fro,to,opt = [select * from LINK_UPDATE];
   --write-b -- Examining next row ($lid$,$fro$,$to$,$opt$) from LINK_UPDATE;
   -- empty working tables NODE_W and LINK_W --
   delete from NODE_W;

   -- Load acyclic graph into working tables --
   --write @S5-- Inserting NODE_A,LINK_A into NODE_W,LINK_W;
   insert into NODE_W select * from NODE_A;
   insert into LINK_W select * from LINK_A;

   -- Load restorable optional links into working table --
   --write @S5-- Inserting translated RESTORED_LINK into LINK_W;
   insert into LINK_W
      select L.LinkID,T1.Substitute as FromNode,
             T2.Substitute as ToNode, L.Opt
      from   TRANSLATION T1, RESTORED_LINK L, TRANSLATION T2
      where  L.FromNode = T1.Source and L.ToNode = T2.Source
      and    T1.Substitute <> T2.Substitute;

   --write @S5-- Next version of LINK_W;
   --select * from LINK_W;

   --Evaluate current optional link --
   --write @S5-- Inserting ($lid$,$fro$,$to$,'Y') into LINK_W;

   insert into LINK_W
      select $lid$,T1.Substitute,T2.Substitute,'Y'
      from   TRANSLATION T1, LINK_UPDATE L, TRANSLATION T2
      where  L.FromNode = T1.Source and L.ToNode = T2.Source
      and    L.LinkID = $lid$;

   --write @S5-- Current version of RESTORED_LINK;
   --select * from RESTORED_LINK;
   --write @S5-- Next version of LINK_W;
   --select * from LINK_W;

   --write @S5-- Remove roots from NODE_W;
   execSQL $sourceDir$/__Remove-Roots-Leaves.sql;
   extract Nnode = select count(*) from NODE_W;
   --write @S5-- Remaining nodes in NODE_W: $Nnode$;
   --write-b @S5-- New state of NODE_W;
   --select * from NODE_W;

   -- if it doesn't create a circuit, move it --
   if ($Nnode$ = 0);
      --write @S5--> Link ($lid$,'$fro$','$to$','$opt$') CAN be restored. Inserted into RESTORED_LINK;
      insert into RESTORED_LINK values($lid$,'$fro$','$to$','$opt$');
   else;
      --write @S5--> Link ($lid$,'$fro$','$to$','$opt$') CANNOT be restored;
   endif;
endfor;

--write Deleting RESTORED_LINK from LINK_UPDATE ;
delete from LINK_UPDATE where LinkID in (select LinkID from RESTORED_LINK);

--write Adding RESTORED_LINK to LINK_A ;
insert into LINK_A
   select L.LinkID,T1.Substitute as FromNode,
          T2.Substitute as ToNode, L.Opt
   from   TRANSLATION T1, RESTORED_LINK L, TRANSLATION T2
   where  L.FromNode = T1.Source and L.ToNode = T2.Source
   and    T1.Substitute <> T2.Substitute;
