-- Create ORDERS database schema

createOrReplaceDB ORDERS.db;
 
create table CUSTOMER (
        CustID char(10) not null,
        Name char(32) not null,
        Address char(60) not null,
        City char(30) not null,
        Cat char(2),
        Account decimal(9,2) not null,
        constraint PKCUST primary key (CustID));

create table PRODUCT (
        ProdID char(15) not null,
        Description char(60) not null,
        Price integer not null,
        QonHand integer not null,
        constraint PKPROD primary key (ProdID));

create table CUSTORDER (
        OrdID char(12) not null,
        CustID char(10) not null,
        DateOrd date not null,
        constraint PKORD primary key (OrdID),
        constraint FKORDCUST foreign key (CustID)
           references CUSTOMER
           on delete no action
           on update cascade);

create table DETAIL (
        OrdID char(12) not null,
        ProdID char(15) not null,
        Qord integer not null,
        constraint PKDET primary key (OrdID,ProdID),
        constraint FKDETORD foreign key (OrdID)
           references CUSTORDER
           on delete cascade
           on update cascade,
        constraint FKDETPROD foreign key (ProdID)
           references PRODUCT
           on delete no action
           on update cascade);

-- Load data

insert into CUSTOMER values
    ('B112','HANSENNE','23, r. Dumont','Poitiers','C1',1250);
insert into CUSTOMER  values
    ('C123','MERCIER','25, r. Lematre','Namur','C1',-2300);
insert into CUSTOMER  values
    ('B332','MONTI','112, r. Neuve','Genve','B2',0);
insert into CUSTOMER  values
    ('F010','TOUSSAINT','5, r. Godefroid','Poitiers','C1',0);
insert into CUSTOMER  values
    ('K111','VANBIST','180, r. Florimont','Lille','B1',720);
insert into CUSTOMER  values
    ('S127','VANDERKA','3, av. des Roses','Namur','C1',-4580);
insert into CUSTOMER  values
    ('B512','GILLET','14, r. de l''Et','Toulouse','B1',-8700);
insert into CUSTOMER  values
    ('B062','GOFFIN','72, r. de la Gare','Namur','B2',-3200);
insert into CUSTOMER  values
    ('C400','FERARD','65, r. du Tertre','Poitiers','B2',350);
insert into CUSTOMER  values
    ('C003','AVRON','8, ch. de la Cure','Toulouse','B1',-1700);
insert into CUSTOMER  values
    ('K729','NEUMAN','40, r. Bransart','Toulouse',null,0);
insert into CUSTOMER  values
    ('F011','PONCELET','17, Cls des Erables','Toulouse','B2',0);
insert into CUSTOMER  values
    ('L422','FRANCK','60, r. de Wpion','Namur','C1',0);
insert into CUSTOMER  values
    ('S712','GUILLAUME','14a, ch. des Roses','Paris','B1',0);
insert into CUSTOMER  values
    ('D063','MERCIER','201, bvd du Nord','Toulouse',null,-2250);
insert into CUSTOMER  values
    ('F400','JACOB','78, ch. du Moulin','Bruxelles','C2',0);

insert into PRODUCT values ('CS262','RAFT. PINE 200x6x2',75,45);
insert into PRODUCT values ('CS264','RAFT. PINE 200x6x4',120,2690);
insert into PRODUCT values ('CS464','RAFT. PINE 400x6x4',220,450);
insert into PRODUCT values ('PA45' ,'NAILS STEEL 45 (1K)',105,580);
insert into PRODUCT values ('PA60' ,'NAILS STEEL 60 (1K)',95,134);
insert into PRODUCT values ('PH222','PL. BEECH 200x20x2',230,782);
insert into PRODUCT values ('PS222','PL. PINE 200x20x2',185,1220);

insert into CUSTORDER values ('30178','K111','2015-12-21');
insert into CUSTORDER values ('30179','C400','2015-12-22');
insert into CUSTORDER values ('30182','S127','2015-12-23');
insert into CUSTORDER values ('30184','C400','2015-12-23');
insert into CUSTORDER values ('30185','F011','2016-01-02');
insert into CUSTORDER values ('30186','C400','2016-01-02');
insert into CUSTORDER values ('30188','B512','2016-01-03');

insert into DETAIL values ('30178','CS464',25);
insert into DETAIL values ('30179','PA60',20);
insert into DETAIL values ('30179','CS262',60);
insert into DETAIL values ('30182','PA60',30);
insert into DETAIL values ('30184','CS464',120);
insert into DETAIL values ('30184','PA45',20);
insert into DETAIL values ('30185','PA60',15);
insert into DETAIL values ('30185','PS222',600);
insert into DETAIL values ('30185','CS464',260);
insert into DETAIL values ('30186','PA45',3);
insert into DETAIL values ('30188','PA60',70);
insert into DETAIL values ('30188','PH222',92);
insert into DETAIL values ('30188','CS464',180);
insert into DETAIL values ('30188','PA45',22);

commitDB;
closeDB;



