-- List expressions --

write -- ----------------------------------------------------- --;
write An SQLfast list is a couple of character strings (S,sep).;
write "S" is made up of items separated by "sep" instances.;
write An item is a character string.;
write Examples:;
write @S4A;B;C;D             with separator ;;
write @S4John//Mary//Andrew  with separator //;
write;
write An item can (but need not) be quoted.;
write Example:;
write @S4John;'Mary';Andrew  with separator ;;
write;
write If an item includes instances of "sep", it must be quoted.;
write Example:;
write @S4John,'Peter, Paul and Mary',Andrew  with separator ,;
write;
write If an item includes quotes, the latter must be doubled and the item;
write must be quoted.;
write Example:;
write @S4John;'O''Hara';Andrew  with separator ;;
write;
write If "sep" is empty, "S" is considered a mere character list.;
write -- ----------------------------------------------------- --;

set S = B;C;E;F;A;G;D;
compute A1 = itemLen('S',';');
compute A2 = itemLen('S','');
compute A3 = item('S',4,';');
compute A4 = itemSlice('S',2,6,';');
compute A5 = itemSlice('S',2,6,'');
compute A6 = itemIndex('S','A',';');
compute A71 = itemSort('S',0,0,';');
compute A72 = itemSort('S',1,0,';');
compute A8 = itemDelete('S','B',';');
compute A9 = itemSort(itemDelete('S','B',';'),0,0,';');

write;
write ** The list:        S = [$S$];
write ** The separator:   sep = ;;
write Length of S:           itemLen(S,';')       = $A1$;
write Length of S:           itemLen(S,'')        = $A2$;
write Extract an item:       item(S,4,';')        = [$A3$];
write Extract a sublist:     itemSlice(S,2,6,';') = [$A4$];
write Extract a sublist:     itemSlice(S,2,6,'')  = [$A5$];
write Index of an item:      itemIndex(S,'A',';') = $A6$;
write Sort a list:           itemSort(S,0,0,';')  = [$A71$];
write Sort a list (inverse): itemSort(S,1,0,';')  = [$A72$];
write Delete items:          itemDelete(S','B',';') = [$A8$];
write Delete then sort:      itemSort(itemDelete(S,'B',';'),0,0,';') = [$A9$];
write;


set S = John-'Paul'-Mary-'O''Hara'-Paul-''-Sarah-'John-John'-John-;
compute A1 = itemLen('S','-');
compute A2 = itemLen('S','');
compute A3 = item('S',4,';');
compute A4 = itemSlice('S',2,6,'-');
compute A5 = itemSlice('S',2,6,'');
compute A6 = itemIndex('S','Mary','-');
compute A7 = itemSort('S',0,0,'-');
compute A8 = itemSort('S',0,1,'-');
compute A9 = itemDelete('S','','-');
compute A10 = itemSort(itemDelete('S','','-'),1,1,'-');
compute A11 = itemSort('23,5,14,-1,1,4,-2',0,0,',');
compute A12 = itemNSort('23,5,14,-1,1,4,-2',0,0,',');


write;
write ** The list:       S = [$S$];
write ** The separator:  sep = -;
write Length of S:        itemLen(S,'-')       = $A1$;
write Length of S:        itemLen(S,'')        = $A2$;
write Extract an item:    item(S,4,'-')        = [$A3$];
write Extract a sublist:  itemSlice(S,2,6,'-') = [$A4$];
write Extract a sublist:  itemSlice(S,2,6,'')  = [$A5$];
write Index of an item:   itemIndex(S,'Mary','-') = $A6$;
write Sort S:             itemSort(S,0,0,'-')  = [$A7$];
write Sort S (distinct):  itemSort(S,0,1,'-')  = [$A8$];
write Delete items:       itemDelete(S,'','-') = [$A9$];
write Delete then sort:   itemSort(itemDelete(S,'','-'),1,1,'-') = [$A10$];
write Char num sort:      itemSort('23,5,14,-1,1,4,-2',0,0,',')  = $A11$;
write Numeric sort:       itemNSort('23,5,14,-1,1,4,-2',0,0,',') = $A12$;
write;


compute L12 = itemUnion('A,D,B,C,B,C','B,D,C,C,E',',');
write Union:              itemUnion('A,D,B,C,B',C,'B,D,C,C,E',',') = $L12$;
compute L12 = itemUnionAll('A,D,B,C,B,C','B,D,C,C,E',',');
write Union all:          itemUnionAll('A,D,B,C,B,C','B,D,C,C,E',',') = $L12$;

compute L12 = itemExcept('A,D,B,C,B,C','B,D,C,C,E',',');
write Except:             itemExcept('A,D,B,C,B,C','B,D,C,C,E',',') = $L12$;
compute L12 = itemExceptAll('A,D,B,C,B,C','B,D,C,C,E',',');
write Except all:         itemExceptAll('A,D,B,C,B,C','B,D,C,C,E',',') = $L12$;

compute L12 = itemInter('A,D,B,C,B,C','B,D,C,C,E',',');
write Intersect:          itemInter('A,D,B,C,B,C','B,D,C,C,E',',') = $L12$;
compute L12 = itemInterAll('A,D,B,C,B,C','B,D,C,C,E',',');
write Intersect all:      itemInterAll('A,D,B,C,B,C','B,D,C,C,E',',') = $L12$;

write;

compute eq = itemEqual('1,3,5,3','3,5,1,1',',');
write Set equality:       itemEqual('1,3,5,3','3,5,1,1',',') = $eq$;
compute eq = itemEqualAll('1,3,5,3','3,5,1,1',',');
write Multiset equality:  itemEqualAll('1,3,5,3','3,5,1,1',',') = $eq$;

write;

compute in = itemInclude('1,3,5,3,1,2','3,5,1,1,3',',');
write Set inclusion:      itemInclude('1,3,5,3,1,2','3,5,1,1,3',',') = $in$;
compute in = itemIncludeAll('1,3,5,3,1,2,3','3,5,1,1,3',',');
write Multiset inclusion: itemIncludeAll('1,3,5,3,1,2,3','3,5,1,1,3',',') = $in$;
compute in = itemIncludeAll('1,3,5,3,1,2,3','3,5,1,1,3,1',',');
write Multiset inclusion: itemIncludeAll('1,3,5,3,1,2,3','3,5,1,1,3,1',',') = $in$;
write;
