-- Parsing a text file, line by line --

-- Fast and simple:
-- ----------------
write-b Fast and simple;
for lin = [file Files/SampleFile.txt] write $lin$;

-- With a for-endfor block:
-- -----------------------
write-b With a for-endfor block;
for lin = [file Files/SampleFile.txt];
  write $lin$;
endfor;

-- Numbering the lines:
-- -------------------
write-b -- Numbering the lines;
set iL = 0;
for lin = [file Files/SampleFile.txt];
  compute iL = $iL$+ 1;
  write [$iL$: $lin$];
endfor;

-- more sophisticated but slower:
-- ------------------------------
write-b -- More sophisticated but slower;
for iL = [1,999999];
  fileToVariable lin = Files/SampleFile.txt #$iL$;
  if ('$FILEdiag$' = 'NONE') exit;
  write [$iL$: $lin$];
endfor;

-- Development of the for-file loop:
-- --------------------------------
write-b -- Development of the for-file loop;
openTextFile Files/SampleFile.txt;
while (True);
  nextTextLine lin = Files/SampleFile.txt;
  if ('$FILEdiag$' <> 'OK') exit;
  write $lin$;
endwhile;
closeTextFile Files/SampleFile.txt;

-- Another development of the for-file loop:
-- ----------------------------------------
write-b -- Another development of the for-file loop;
openTextFile Files/SampleFile.txt;
nextTextLine lin = Files/SampleFile.txt;
while ('$FILEdiag$' = 'OK');
  write $lin$;
  nextTextLine lin = Files/SampleFile.txt;
endwhile;
closeTextFile Files/SampleFile.txt;

-- Copy a text file, line by line --
-- ------------------------------ --
write-b -- Copy text file "Files/SampleFile.txt", line by line --

-- The new file will be created in default directory "Output"
outputOpen Copy_SampleFile.txt;
for lin = [file Files/SampleFile.txt] write $lin$;
outputAppend window;
write @S3File "Output/Copy_SampleFile.txt" created --

-- Here, directory "Output" must be specified
fileToVariable txt = Output/Copy_SampleFile.txt;
write @S3File "Output/Copy_SampleFile.txt" reloaded and displayed --

write-b $txt$;

write-a ... then deleted;
deleteFile Output/Copy_SampleFile.txt;
