
write-b -- ----------------------------------------- --;
write   -- Encoding/Decoding through HEX statements  --;
write-a -- ----------------------------------------- --;

write -- 1. Encoding / decoding "rue de l't" --;
set A = rue de l't;
HEXencodeVarToVar hexA = A;
write [$A$] ==> [$hexA$];
HEXdecodeVarToVar B = hexA;
write [$hexA$] ==> [$B$];

write-b -- 2. Encoding / decoding "rue de l't" through file "hexA.txt" --;
set A = rue de l't;
HEXencodeVarToFile Files/hexA.txt = A;
HEXdecodeFileToVar C = Files/hexA.txt;
write C = [$C$];

write-b -- 3. Decoding "rue de l't" from file "hexA.txt" --;
HEXdecodeFileToVar D = Files/hexA.txt;
write D = [$D$];

write-b -- 4. Decoding "rue de l't" from file "hexA.txt" into file "E.txt" --;
HEXdecodeFileToFile Files/E.txt = Files/hexA.txt;
fileToVariable E = Files/E.txt;
write E = [$E$];

write-b -- 5. Encoding "rue de l't" from file "SampleFile.txt" into file "hexF.txt" --;
write -- then Decoding it into file "hex-SampleFile.txt"                          --;
HEXencodeFileToFile Files/hexF.txt = Files/SampleFile.txt;
HEXdecodeFileToFile Files/hex-SampleFile.txt = Files/hexF.txt;
fileToVariable F = Files/hex-SampleFile.txt;
write F = [$F$];

write-b -- 6. Encoding / decoding file "JeuxDePlage.gif" into file "hex-JeuxDePlage.gif" --;
HEXencodeFileToVar G = Files/JeuxDePlage.gif;
HEXdecodeVarToFile Files/hex-JeuxDePlage.gif = G;

pause Examine new files @n@t"hexA.txt", @n@t"E.txt", 
                        @n@t"hexF.txt", @n@t"hex-SampleFile.txt",
                        @n@t"hex-JeuxDePlage.gif" in folder "Files";
pause Now, deleting work files;

deleteFile Files/hexA.txt;
deleteFile Files/E.txt;
deleteFile Files/hexF.txt;
deleteFile Files/hex-SampleFile.txt;
deleteFile Files/hex-JeuxDePlage.gif;

write-b -- ----------------------------------------- --;
write   -- Encoding/Decoding through HEX functions   --;
write   -- ----------------------------------------- --;

-- Decode Latin-1 hex code
set hexa1 = e974e9;
compute char1 = hex2char('$hexa1$');
write-b -- Convert Latin-1 hex code;
write $hexa1$ = [$char1$];

-- Decode utf-8   hex code
set hexa2 = c3a974c3a9;
compute char2 = hex2char('$hexa2$');
write-b -- Convert utf-8   hex code;
write $hexa2$ = [$char2$];

-- Decode Not printable hex code
set hexa3 = 37001270fa;
compute char3 = hex2char('$hexa3$');
write-b -- Convert Not printable hex code;
write $hexa3$ = [$char3$];

set A = rue de l't;
compute B = char2hex('A');
compute C = hex2char(char2hex('A'));
write-b A: $A$;
write   B: $B$;
write-a C: $C$;

fileToVariable D = Files/SampleFile.txt;
compute E = hex2char(char2hex('D'));
variableToFile E = Files/SampleFile-Copy.txt;

pause Now, examine work file "Files/SampleFile-Copy.txt";
deleteFile Files/SampleFile-Copy.txt;
