write-b -- --------------------- --;
write   -- encryption functions  --;
write-a -- --------------------- --;

openDB ORDERS.db;

write-b Current state of table CUSTOMER:;
select * from CUSTOMER;

write-b Encrypt the name of a customer;

ask cid,nam,key = [/bUpdate and encrypt the name of a selected customer]
                  CustID:[select CustID from CUSTOMER 
                          order by CustID]
                 |New name:|Encryption key:;
update CUSTOMER 
  set  Name = encrypt('$nam$','$key$') 
  where CustID = '$cid$';

write-b New state of the data:;
select CustID,Name from CUSTOMER where CustID = '$cid$';

write-b Decoding encrypted data:;
select CustID,Name,decrypt(Name,'$key$') as "decoded Name"
from   CUSTOMER where CustID = '$cid$';

abortDB;
closeDB;

write-b -- ------------------------------ --;
write   -- encryp/decrypt table CUSTOMER  --;
write-a -- ------------------------------ --;

openDB ORDERS.db;

select CustID,Name,Address,City,Cat,Account from CUSTOMER;
ask key = Encryption key:;

update CUSTOMER
set Name    = encrypt(Name,'$key$'),
    Address = encrypt(Address,'$key$'),
    City    = encrypt(City,'$key$'),
    Cat     = encrypt(Cat,'$key$'),
    Account = encrypt(Account,'$key$');

write-b CUSTOMER has been completely encrypted:;
select CustID,Name,Address,City,Cat,Account from CUSTOMER;

write-b Now, we decrypt the data.;
-- Two problems to address:
-- * recovering "null" values from empty strings,
-- * converting numeric strings into numeric values.
update CUSTOMER
set Name =    decrypt(Name,'$key$'),
    Address = decrypt(Address,'$key$'),
    City =    decrypt(City,'$key$'),
    Cat =     case when decrypt(Cat,'$key$') = ''
                   then null
                   else decrypt(Cat,'$key$')
              end,
    Account = cast(decrypt(Account,'$key$') as decimal);

write-b CUSTOMER table has been completely decrypted:;
select CustID,Name,Address,City,Cat,Account from CUSTOMER;

abortDB;
closeDB;

write-b -- ------------------------------ --;
write   -- encryp/decrypt table CUSTOMER  --;
write   -- Preventing data inference      --;
write-a -- ------------------------------ --;

write The values of the columns are concatenated into a single,;
write long, character string, that is then encrypted.;
write The concatenation forms a sequence of values separated by '', for example.;

openDB ORDERS.db;

update CUSTOMER
set Name = encrypt(Name
                 ||''||Address
                 ||''||City
                 ||''||coalesce(Cat,'')
                 ||''||cast(Account as char),'$key$'),
         Address = '',
         City = '',
         Cat = '',
         Account = 0;

write-b CUSTOMER table has been encrypted:;
select CustID,Name,Address,City,Cat,Account from CUSTOMER;

update CUSTOMER
set Name    = item(decrypt(Name,'$key$'),1,''),
    Address = item(decrypt(Name,'$key$'),2,''),
    City    = item(decrypt(Name,'$key$'),3,''),
    Cat     = case when item(decrypt(Name,'$key$'),4,'') = '' 
                   then null 
                   else item(decrypt(Name,'$key$'),4,'')
              end,
    Account = cast(item(decrypt(Name,'$key$'),4,'') as decimal);

write-b CUSTOMER table has been completely decrypted:;
select CustID,Name,Address,City,Cat,Account from CUSTOMER;

abortDB;
closeDB;
