
showMessage This small application stores in database "IMAGES.db"@n
            the images of a selected folder,@n
            then shows these images with their metadata.@n
            Click to start.; 

if (fileExists('Databases/IMAGES.db'));
   openDB IMAGES.db;
   write Database "IMAGES.db" found;
else;
   createDB IMAGES.db;
   create table IMAGE (ImID      integer not null primary key autoincrement,
                       ImFile    varchar(256),
                       ImType    varchar(20),
                       ImSize    integer,
                       ImDir     varchar(256),
                       ImLastUpd datetime,
                       ImLastAcc datetime,
                       Contents  blob);
   create view IMAGE_DATA as
   select ImID,ImFile,ImType,ImSize,ImDir,ImLastUpd,ImLastAcc,
          case when Contents is null
               then null
               else '<image>'
          end as "Contents"
   from IMAGE;
   write Database "IMAGES.db" created;
endif;

selectDirectory dir = D:/SQLfast;
fileNames Files/images.txt = {$dir$},gif;

start-timer;
set Nim = 0;
for imadd = [file Files/images.txt];
   function x,dir,x,lname,ext  = LFile:splitPath {$imadd$};
   function size,x,mTime,aTime = LFile:infoFile {$imadd$};
   insert into IMAGE(ImFile,ImType,ImSize,ImDir,ImLastUpd,ImLastAcc)
          values ('lname','$ext$',$size$,'dir','$mTime$','$aTime$');
   extract last = select max(ImID) from IMAGE;
   BfileToVariable cont = $imadd$;
   insertLob cont = Contents from IMAGE where ImID = $last$;
   compute Nim = $Nim$ + 1;
endfor;
write-b $Nim$ images loaded in $timer$ seconds;
extract N,S = select count(1),length(Contents) from IMAGE;
write The database contains $N$ images for a total of $S$ bytes;

commitDB;
closeDB;

openDB IMAGES.db;
parameter entryWidth = 50;
for id,nam,size,upd,acc,cont = [select ImID,ImFile,ImSize,ImLastUpd,ImLastAcc,Contents from IMAGE];
   askCombo [/bPicture viewer]
            [ask-u id,nam,size,upd,acc = ID:|Name:|Size:|Update|Accessed:]
           |[showPicture cont = [/y300]];
   if ('$DIALOGbutton$' = 'Cancel') exit;
endfor;

closeDB;
