-- Dumping and reloading a database through CSV save files --

openDB ORDERS.db;

-- change "null" representation to ''
set stdNull = $dispNull$;
set dispNull = ;

-- No header
set csv-header = 0;

execSQL UTIL-SELECT-parameters-for-CSV.sql;

-- Generate CSV files
outputOpen $fileDirectory$/CUSTOMER-dump.csv;
select * from CUSTOMER;
outputOpen $fileDirectory$/CUSTORDER-dump.csv;
select * from CUSTORDER;
outputOpen $fileDirectory$/DETAIL-dump.csv;
select * from DETAIL;
outputOpen $fileDirectory$/PRODUCT-dump.csv;
select * from PRODUCT;
outputAppend window;

-- restore current "null" representation
set dispNull = $stdNull$;

execSQL UTIL-SELECT-parameters-standard-1.sql;

-- Clear table
delete from DETAIL;
delete from CUSTORDER;
delete from CUSTOMER;
delete from PRODUCT;

-- Reload data
import CUSTOMER  from $fileDirectory$/CUSTOMER-dump.csv;
import PRODUCT   from $fileDirectory$/PRODUCT-dump.csv;
import CUSTORDER from $fileDirectory$/CUSTORDER-dump.csv;
import DETAIL    from $fileDirectory$/DETAIL-dump.csv;
commitDB;

-- Check result
select * from CUSTOMER;
select * from CUSTORDER;
select * from DETAIL;
select * from PRODUCT;

-- Delete temporary CSV files
deleteFile $fileDirectory$/CUSTOMER-dump.csv;
deleteFile $fileDirectory$/PRODUCT-dump.csv;
deleteFile $fileDirectory$/CUSTORDER-dump.csv;
deleteFile $fileDirectory$/DETAIL-dump.csv;

closeDB;
