-- Dumping and reloading a database through CSV save files      --
-- More general version of "CSV-Dump-and-Reload-1.sql"          --
-- Suggestion: make it DB-independent through "Dictionary"      --
-- WARNING: in leval 1, "import" starts a transaction           --
--          but doesn't close it.                               --

openDB ORDERS.db;

set stdNull = $dispNull$;
set dispNull = ;

-- No header
set csv-header = 0;

execSQL UTIL-SELECT-parameters-for-CSV.sql;

for table = [item(;) DETAIL;CUSTORDER;CUSTOMER;PRODUCT];
    write-b --- Export table $table$;
    outputOpen $fileDirectory$/$table$-dump.csv;
    select * from $table$;
    outputAppend window;
    delete from $table$;
    write --- Table $table$ emptied ---;
endfor;

execSQL UTIL-SELECT-parameters-standard-1.sql;

write-b ============ State after export =================;
select * from CUSTOMER;
select * from PRODUCT;
select * from CUSTORDER;
select * from DETAIL;
write ==========================================;

-- restore current "null" representation
set dispNull = $stdNull$;

write-b ============ State after import =================;
for table = [item(;) CUSTOMER;PRODUCT;CUSTORDER;DETAIL];
    import  $table$ from $fileDirectory$/$table$-dump.csv;
    write --- Table $table$ imported ---;
    select * from $table$;
    write $ImportErrors$ errors for table $table$;
    deleteFile $fileDirectory$/$table$-dump.csv;
endfor;
write-a ==========================================;

-- Commit the last import --
commitDB;

closeDB;

