-- The if-then-else structure cope with the SQLite "with" bug
-- Bug: when a with query returns an empty result set, the cursor.description
--      method returns None instead of the list of column names.
-- To simplify when the bug is fixed -- 

openDB STAFF.db;

ask P = PersonID:[!select PID from PERSON];

extract NP = select count(*) from PERSON where PID = '$P$';

write-ab Graphical representation of the hierarchy of person $P$.;

if ($NP$ = 0);
   select 1 as Dist,1 as PID,1 as Name,1 as Manager,1 as Path 
   from PERSON where 1 = 2;
else;
   with recursive PATHS(Dist,PID,Name,Manager,Path)
   as (select 0,PID,Name,Manager,'.'||PID||'.' from PERSON where PID = '$P$'
         union all
       select O.Dist+1,P.PID,P.Name,P.Manager,O.Path||P.PID||'.'
       from   PATHS O, PERSON P where O.PID = P.Manager
       )
   select substr('------',1,2*Dist)||PID||' ['||Name||']' as Person,Path
   from   PATHS order by Path;
endif;

closeDB;
