-- ----------------------------------------------------------- --
-- Displaying the schema of a database in the "Summary" format --
-- ----------------------------------------------------------- --

write-ab -- Displaying the schema of ORDERS.db in the "Summary" format --;
openDB ORDERS.db;
createDictionary;

set bar11,bar12,bar13,bar14 = ,,,;
set bar21,bar22,bar23,bar24 = ,,,;
set bar31,bar32,bar33,bar34 = ,,,;
set head1,head2,head3,head4 = ,,,;
set data1,data2,data3,data4 = ,@v,@s,@n;

select TableName,ColName,ColType
from (select TableID,
             0                   as ColSeq,
             'Table '||TableName as TableName,
             ''                  as ColName,
             ''                  as ColType
      from SYS_TABLE
         union
      select TableID,
             ColSeq,
             ''                  as TableName,
             ColName,
             case when ColType in ('numeric','decimal')
                     then ColType||'('||cast(ColLen1 as char)||','||cast(ColLen2 as char)||')'
                  when ColType in ('char','varchar') 
                     then ColType||'('||cast(ColLen1 as char)||')'
                  else ColType
             end                 as ColType
     from SYS_COLUMN)
order by TableID,ColSeq;

execSQL UTIL-SELECT-parameters-standard-1.sql;

closeDB;
