
if (not fileExists('$dbDirectory$/TRACING.db'));
  showMessage @nThe tracing database "TRACING.db" is missing.@nPlease create it first.@n;
  return;
endif;

openDB TRACING.db;

write-b -- Where are variables set?        --;
        -- ------------------------------- --
select Variable,Tproc,AssignedIn,Tindex,Tproc,RawStat
from   VARIABLES, TRACES
where  AssignedIn = TraceID
and    Tnature < 2
order by AssignedIn;

write-b -- Where are variables used?        --;
        -- -------------------------------- --
select distinct V.Variable,T.Tproc,T.Tindex,T.TraceID,T.RawStat
from   TRACES T, VARIABLES V
where  Tnature < 2 
and    T.RawStat like '%$'||V.Variable||'$%'
order by T.TraceID;

write-b -- Compute data flow of variables   --;
        -- -------------------------------- --
create temp view VARIABLE_FLOW(Variable,TraceID,
       Set_in,Set_by_statement,Used_in,Used_by_statement) as
select Variable,TraceID,Tproc||':'||Tindex,RawStat,'',''
from   VARIABLES, TRACES
where  AssignedIn = TraceID
and    Tnature in (0,1)
    union
select Variable,TraceID,'','',Tproc||':'||Tindex,RawStat
from   VARIABLES V, TRACES T
where  Tnature in (0,1) 
and    RawStat like '%$'||Variable||'$%';

select * from VARIABLE_FLOW order by Variable,TraceID;

write-ba -- Display the history of a selected variable --;
         -- ------------------------------------------ --
ask var = [Select a variable] variable:[!select distinct Variable from VARIABLES order by Variable];
if ('$DIALOGbutton$' = 'Cancel') stop;

for tid,setin,setby,usedin,usedby = [select TraceID,Set_in,Set_by_statement,Used_in,Used_by_statement 
                                     from   VARIABLE_FLOW
                                     where  Variable = '$var$' order by TraceID];
  parameter delimiters = { };
  if ('{setin}' <> '');
    write Variable "{var}" is set by statement:@n@S6"{setby}" in {setin} [{tid}];
    set used = 0;
  else;
    if ({used} = 0);
       write ... then used in statement(s):;
       set used = 1;
    endif;
    write @S6"{usedby}" in {usedin} [{tid}]; 
  endif;
  parameter delimiters = default;
endfor;

parameter delimiters = default;

closeDB;
