
if (not fileExists('$dbDirectory$/TRACING.db'));
  showMessage @nThe tracing database "TRACING.db" is missing.@nPlease create it first.@n;
  return;
endif;

set maxSelectWidth = 80;

openDB TRACING.db;

write-b -- Number of statements and traces per Procedure --;
        -- --------------------------------------------- --
select Tproc,count(distinct Tindex) as Statements,count(*) as Traces 
from   TRACES 
group by Tproc;

write-b -- Number of traces per statement nature --;
        -- ------------------------------------- --
select case Tnature when 0 then 'Native elementary'
                    when 1 then 'Native complex'
                    else 'Generated elementary' end as Nature,
       count(*) as Traces
from   TRACES 
group by Tnature;

write-b -- Raw statements traces in procedure "TRACING_Main" --;
        -- -------------------------------------------------- --
select Tindex,RawStat from TRACES where Tproc = 'TRACING-Main' and Tnature < 2 order by TraceID;

write-b -- Elementary statements traces (native and generated) in procedure "TRACING_Main" --;
        -- -------------------------------------------------------------------------------- --
select Tindex,RawStat from TRACES where Tproc = 'TRACING-Main' and Tnature in (0,2) order by TraceID;


closeDB;
