createDB InMemory;

write-b Exercise: Which set of products is bought by which set of cities?;

create table CUSTOMER (CustID char(10),City char(20));
create table CUSTORDER(OrdID char(10), CustID char(10));
create table DETAIL   (OrdID char(10), ProdID char(10));

insert into CUSTOMER values  ('B332','Toulouse'),('C400','Toulouse'),
                             ('S127','London'),
                             ('D063','Paris'),('F400','Bruxelles'),('L422','Genve'),
                             ('B512','Poitiers'),('C003','Lille');

insert into CUSTORDER values ('30452','B332'),('30453','B332'),('30454','C400'),
                             ('30455','S127'),
                             ('30456','D063'),('30457','F400'),('30458','F400'),
                             ('30459','L422'),
                             ('30460','B512'),('30461','C003');

insert into DETAIL values    ('30452','PA60'),('30452','CS262'),('30453','CS262'),
                             ('30454','PS222'),('30454','PA60'),
                             ('30455','PA60'),('30455','CS262'),('30455','PS222'),
                             ('30456','PA45'),('30456','CS262'),
                             ('30457','CS262'),('30458','PA45'),
                             ('30459','PA45'),('30459','CS262'),
                             ('30460','PA45'),('30461','PA45');

write-b -- Table BUY: "in this City one buys this Product" --;
create table BUY as
   select distinct City,ProdID
   from   CUSTOMER C, CUSTORDER O, DETAIL D
   where  O.CustID = C.CustID and D.OrdID = O.OrdID;

select City,ProdID from BUY;

write-b -- Table EQUAL: "in City1 and City2, one buys the same set of Products" --;
create table EQUAL as
   with CP(City,PSet) as
       (select City,group_concat(ProdID,',')
        from   BUY group by City)
   select C1.City as City1,C2.City as City2,
          itemSort(C1.PSet,0,0,',') as Products
   from   CP C1, CP C2
   where  C1.City <> C2.City
   and    itemEqual(C1.PSet,C2.PSet,',');

select * from EQUAL;

write-b -- "this set of Products is bought by each of these Cities" --;
select Products,group_concat2(City1,1,0,1,',') as Cities
from   EQUAL
group by Products;

closeDB;
